/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StraightNumericAxisBase } from "./StraightNumericAxisBase";
import { IScaler_$type } from "./IScaler";
import { markType, TypeRegistrar } from "igniteui-angular-core";
import { HorizontalAxisLabelPanel } from "./HorizontalAxisLabelPanel";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-angular-core";
import { RangeInfo } from "./RangeInfo";
import { HorizontalLogarithmicScaler } from "./HorizontalLogarithmicScaler";
import { FastHorizontalLinearScaler } from "./FastHorizontalLinearScaler";
import { isNaN_ } from "igniteui-angular-core";
import { StraightNumericAxisBaseView } from "./StraightNumericAxisBaseView";
/**
 * @hidden
 */
export class NumericXAxis extends StraightNumericAxisBase {
    constructor() {
        super();
        this.ab = NumericXAxis.$;
        this.jm = this.jk();
    }
    a2() {
        return new NumericXAxisView(this);
    }
    gx(a) {
        super.gx(a);
        this.l2 = a;
    }
    at() {
        if (this.cr) {
            return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
        }
        else {
            return new HorizontalAxisLabelPanel();
        }
    }
    jk() {
        let a = super.jk();
        a.b.c = (b) => {
            if ((this.ax == null || this.ax.visibility == 0) && this.ah != null) {
                this.au.a8 = b;
                if (this.ax != null && (this.ax.location == 4 || this.ax.location == 5)) {
                    this.bh.hu();
                }
            }
        };
        a.k = (b, c, d) => this.hk(c, d, b.z, b.b, false);
        a.l = (b, c, d, e) => this.hl(c, d, e, b.z);
        a.m = (b, c) => {
            let d = b.y;
            let e = new ScalerParams(0, b.aa, b.z, this.cb, d);
            return this.dy(c, e);
        };
        a.q = (b, c) => true;
        a.j = (b) => this.gv(b.t, b.n, b.z, b.a, true);
        a.e = (b) => {
            b.n = b.z.bottom;
            if (this.ah != null && this.ah.bh != null) {
                let c = b.n;
                let d = b.r;
                let e = this.hf(c, d, b.aa, b.z, b.y, b.z.top, b.z.bottom);
                c = e.p0;
                d = e.p1;
                b.n = c;
                b.r = d;
            }
        };
        a.p = (b, c, d) => {
            let e = Math.round(c);
            return e >= Math.floor(b.z.left) && e <= Math.ceil(b.z.right);
        };
        return a;
    }
    dy(a, b) {
        if (this.ll != null) {
            return this.ll.p(a, b);
        }
        return this.lk.p(a, b);
    }
    d1(a, b) {
        if (this.ll != null) {
            return this.ll.q(a, b);
        }
        return this.lk.q(a, b);
    }
    gs(a, b, c, d) {
        if (this.ll != null) {
            this.ll.v(a, b, c, d);
            return;
        }
        this.lk.v(a, b, c, d);
    }
    gr(a, b, c, d, e) {
        if (this.ll != null) {
            this.ll.u(a, b, c, d, e);
            return;
        }
        this.lk.u(a, b, c, d, e);
    }
    gt(a, b, c, d) {
        if (this.ll != null) {
            this.ll.j(a, b, c, d);
            return;
        }
        this.lk.j(a, b, c, d);
    }
    l3(a, b) {
        if (this.bh == null || a == NaN || b == NaN) {
            return;
        }
        let c = this.lq(a, this);
        let d = this.lq(b, this);
        if (c == NaN || d == NaN) {
            return;
        }
        this.bh.m6 = new Rect(0, c, this.bh.m6.y, d - c, this.bh.m6.height);
    }
    jn(a, b, c, d) {
        let e = d;
        let f = super.jn(a, b, c, d);
        let g = new ScalerParams(0, b, a, this.ca, c);
        let h = NaN;
        let i = NaN;
        if (!this.ca && b.right == 1) {
            i = this.ka;
        }
        else if (this.ca && b.left == 0) {
            h = this.ka;
        }
        if (isNaN_(h)) {
            h = this.d1(e.left, g);
        }
        if (isNaN_(i)) {
            i = this.d1(e.right, g);
        }
        let j = Math.min(h, i);
        let k = Math.max(h, i);
        this.ke = j;
        this.kd = k;
        f.k.add(((() => {
            let $ret = new RangeInfo();
            $ret.d = j;
            $ret.c = k;
            $ret.b = e.width;
            return $ret;
        })()));
        return f;
    }
    hc(a) {
        super.hc(a);
        let b = this.bh != null ? this.bh.mr : Rect.empty;
        let c = !b.isEmpty ? this.i8 : Rect.empty;
        let d = this.i3();
        let e = this.i2();
        let f = this.jm.c(a, c, b, d, e);
        if (f != null) {
            this.j9 = f.f.m;
            this.kc = f.f.l;
        }
    }
    hm(a, b) {
        super.hm(a, b);
        if (b.height != a.height) {
            this.cn();
        }
    }
    get_a0() {
        return 0;
    }
    get a0() {
        return this.get_a0();
    }
    jp() {
        if (this.j0) {
            return new HorizontalLogarithmicScaler();
        }
        switch (this.lj) {
            case 0: return new FastHorizontalLinearScaler();
            case 1: return new HorizontalLogarithmicScaler();
        }
        return null;
    }
    j$c(a, b) {
        return this.d1.apply(this, arguments);
    }
    j$b(a, b) {
        return this.dy.apply(this, arguments);
    }
    j$d(a, b, c, d, e) {
        this.gr.apply(this, arguments);
    }
    j$e(a, b, c, d) {
        this.gs.apply(this, arguments);
    }
    j$f(a, b, c, d) {
        this.gt.apply(this, arguments);
    }
    get j$a() {
        return this.ca;
    }
}
NumericXAxis.$t = markType(NumericXAxis, 'NumericXAxis', StraightNumericAxisBase.$, [IScaler_$type]);
/**
 * @hidden
 */
export class NumericXAxisView extends StraightNumericAxisBaseView {
    constructor(a) {
        super(a);
        this.bi = null;
        this.bi = a;
    }
}
NumericXAxisView.$t = markType(NumericXAxisView, 'NumericXAxisView', StraightNumericAxisBaseView.$);
//# sourceMappingURL=NumericXAxis_combined.js.map