/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StraightNumericAxisBase } from "./StraightNumericAxisBase";
import { IScaler_$type } from "./IScaler";
import { markType } from "igniteui-angular-core";
import { VerticalAxisLabelPanel } from "./VerticalAxisLabelPanel";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { RangeInfo } from "./RangeInfo";
import { VerticalLogarithmicScaler } from "./VerticalLogarithmicScaler";
import { FastVerticalLinearScaler } from "./FastVerticalLinearScaler";
import { isNaN_ } from "igniteui-angular-core";
import { StraightNumericAxisBaseView } from "./StraightNumericAxisBaseView";
/**
 * @hidden
 */
export class NumericYAxis extends StraightNumericAxisBase {
    constructor() {
        super();
        this.ab = NumericYAxis.$;
        this.jm = this.jk();
    }
    a2() {
        return new NumericYAxisView(this);
    }
    at() {
        return new VerticalAxisLabelPanel();
    }
    get_ch() {
        return true;
    }
    dx() {
        return this.i8.height;
    }
    dy(a, b) {
        if (this.ll != null) {
            return this.ll.p(a, b);
        }
        return this.lk.p(a, b);
    }
    gs(a, b, c, d) {
        if (this.ll != null) {
            this.ll.v(a, b, c, d);
            return;
        }
        this.lk.v(a, b, c, d);
    }
    gr(a, b, c, d, e) {
        if (this.ll != null) {
            this.ll.u(a, b, c, d, e);
            return;
        }
        this.lk.u(a, b, c, d, e);
    }
    d1(a, b) {
        if (this.ll != null) {
            return this.ll.q(a, b);
        }
        return this.lk.q(a, b);
    }
    gt(a, b, c, d) {
        if (this.ll != null) {
            this.ll.j(a, b, c, d);
            return;
        }
        this.lk.j(a, b, c, d);
    }
    l2(a, b) {
        if (this.bh == null || a == NaN || b == NaN) {
            return;
        }
        let c = this.lq(a, this);
        let d = this.lq(b, this);
        if (c == NaN || d == NaN) {
            return;
        }
        this.bh.m6 = new Rect(0, this.bh.m6.x, d, this.bh.m6.width, c - d);
    }
    jk() {
        let a = super.jk();
        a.b.c = (b) => {
            if (this.ax == null || this.ax.visibility == 0) {
                this.au.a8 = b;
                if (this.ax != null && (this.ax.location == 7 || this.ax.location == 6)) {
                    this.bh.hu();
                }
            }
        };
        a.k = (b, c, d) => this.gv(c, d, b.z, b.b, false);
        a.l = (b, c, d, e) => this.gw(c, d, e, b.z);
        a.m = (b, c) => {
            let d = b.y;
            let e = new ScalerParams(0, b.aa, b.z, this.cb, d);
            return this.dy(c, e);
        };
        a.q = (b, c) => true;
        a.j = (b) => this.hk(b.t, b.n, b.z, b.a, true);
        a.e = (b) => {
            b.n = this.ax != null && (this.ax.location == 7 || this.ax.location == 3) ? b.z.right : b.z.left;
            let c = b.y;
            let d = new ScalerParams(0, b.aa, b.z, this.cb, c);
            if (this.ah != null && this.ah.bh != null) {
                let e = b.n;
                let f = b.r;
                let g = this.hf(e, f, b.aa, b.z, b.y, b.z.left, b.z.right);
                e = g.p0;
                f = g.p1;
                b.n = e;
                b.r = f;
            }
        };
        a.p = (b, c, d) => {
            let e = Math.round(c);
            return e >= Math.floor(b.z.top) && e <= Math.ceil(b.z.bottom);
        };
        return a;
    }
    jn(a, b, c, d) {
        let e = d;
        let f = super.jn(a, b, c, d);
        let g = new ScalerParams(0, b, a, this.ca, c);
        let h = NaN;
        let i = NaN;
        if (!this.ca && b.top == 0) {
            i = this.ka;
        }
        else if (this.ca && b.bottom == 1) {
            h = this.ka;
        }
        if (isNaN_(h)) {
            h = this.d1(e.bottom, g);
        }
        if (isNaN_(i)) {
            i = this.d1(e.top, g);
        }
        let j = Math.min(h, i);
        let k = Math.max(h, i);
        this.ke = j;
        this.kd = k;
        let l = ((() => {
            let $ret = new RangeInfo();
            $ret.d = j;
            $ret.c = k;
            $ret.b = e.height;
            return $ret;
        })());
        f.k.add(l);
        return f;
    }
    hc(a) {
        super.hc(a);
        let b = this.bh != null ? this.bh.mr : Rect.empty;
        let c = this.i8;
        let d = this.i3();
        let e = this.i2();
        let f = this.jm.c(a, c, b, d, e);
        if (f != null) {
            this.j9 = f.f.m;
            this.kc = f.f.l;
        }
    }
    hm(a, b) {
        super.hm(a, b);
        if (b.height != a.height) {
            this.cn();
        }
    }
    get_a0() {
        return 1;
    }
    get a0() {
        return this.get_a0();
    }
    jp() {
        if (this.j0) {
            return new VerticalLogarithmicScaler();
        }
        switch (this.lj) {
            case 0: return new FastVerticalLinearScaler();
            case 1: return new VerticalLogarithmicScaler();
        }
        return null;
    }
    j$c(a, b) {
        return this.d1.apply(this, arguments);
    }
    j$b(a, b) {
        return this.dy.apply(this, arguments);
    }
    j$d(a, b, c, d, e) {
        this.gr.apply(this, arguments);
    }
    j$e(a, b, c, d) {
        this.gs.apply(this, arguments);
    }
    j$f(a, b, c, d) {
        this.gt.apply(this, arguments);
    }
    get j$a() {
        return this.ca;
    }
}
NumericYAxis.$t = markType(NumericYAxis, 'NumericYAxis', StraightNumericAxisBase.$, [IScaler_$type]);
/**
 * @hidden
 */
export class NumericYAxisView extends StraightNumericAxisBaseView {
    constructor(a) {
        super(a);
        this.bi = null;
        this.bi = a;
    }
}
NumericYAxisView.$t = markType(NumericYAxisView, 'NumericYAxisView', StraightNumericAxisBaseView.$);
//# sourceMappingURL=NumericYAxis_combined.js.map