/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FastItemDateTimeColumn } from "igniteui-angular-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ISortingAxis_$type } from "./ISortingAxis";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { DependencyProperty } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { typeCast, Number_$type, Date_$type, fromEnum, runOn, delegateRemove, delegateCombine, markType, markDep, TypeRegistrar } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-angular-core";
import { NumericScaler } from "./NumericScaler";
import { SeriesViewer } from "./SeriesViewer";
import { SortedListView$1 } from "./SortedListView$1";
import { ArrayExtension } from "igniteui-angular-core";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { HorizontalAxisLabelPanel } from "./HorizontalAxisLabelPanel";
import { MathUtil } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate, isNaN_ } from "igniteui-angular-core";
import { dateMinValue, dateSubtract, dateAdd, dateMaxValue, dateFromTicks } from "igniteui-angular-core";
/**
 * @hidden
 */
export class TimeAxisBase extends CategoryAxisBase {
    constructor() {
        super();
        this.k3 = null;
        this.lc = null;
        this.k7 = false;
        this.lf = dateMaxValue();
        this.le = dateMinValue();
        FastItemDateTimeColumn.o();
    }
    dy(a, b) {
        if (!b.c.isEmpty) {
            let c = this.lk(a, NumericScaler.ac, b.c, Rect.empty);
            c = (c - b.d.left) / b.d.width;
            c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
            return c;
        }
        return this.lk(a, b.e, b.d, b.c);
    }
    e6(a, b) {
        let c = this.f0(b);
        if (c == this.dateTimeMemberPath) {
            return this.e7(a, b, this.dateTimeMemberPath);
        }
        return super.e6(a, b);
    }
    lk(a, b, c, d) {
        let e;
        if (+(this.actualMaximumValue) == +(this.actualMinimumValue)) {
            e = -1;
        }
        else {
            e = (a - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
        }
        let f = 0;
        if (this.categoryMode == 2) {
            f = this.getGroupCenter(0, b, c, d);
        }
        if (this.ca) {
            e = 1 - e;
            f = -f;
        }
        return c.left + c.width * (e - b.left) / b.width - f;
    }
    ll(a, b, c) {
        let d;
        if (+(this.actualMaximumValue) == +(this.actualMinimumValue)) {
            d = -1;
        }
        else {
            d = (a - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
        }
        let e = 0;
        if (this.ca) {
            d = 1 - d;
            e = -e;
        }
        return c.left + c.width * (d - b.left) / b.width - e;
    }
    d1(a, b) {
        if (!b.c.isEmpty) {
            let c = b.d.left;
            let d = b.d.width;
            if (this.categoryMode != 0) {
                let e = this.getCategorySize(b.e, b.d, b.c);
                c += e / 2;
                d -= e;
            }
            let f = b.e.left + b.e.width * (a - c) / b.d.width;
            f = (f * b.d.width) + b.d.left;
            f = this.getUnscaledValue3(f, NumericScaler.ac, b.c, this.categoryMode);
            return f;
        }
        return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
    }
    getUnscaledValue3(a, b, c, d) {
        let e = b.left + b.width * (a - c.left) / c.width;
        if (this.ca) {
            e = 1 - e;
        }
        return truncate(Math.floor(this.actualMinimumValue.getTime() + e * (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime())));
    }
    i$h() {
        this.l0();
    }
    l0() {
        let a = this.bh != null ? this.bh.mr : Rect.empty;
        let b = !a.isEmpty ? this.i8 : Rect.empty;
        let c = (new Date());
        let d = (new Date());
        let e = false;
        if (!a.isEmpty && !b.isEmpty && this.k4 != null) {
            let f = typeCast(FastItemDateTimeColumn.$, this.k4);
            if (f != null) {
                if (this.ld == null) {
                    this.l1();
                }
            }
            else {
                this.ld = null;
            }
            if (this.k4.count > 0) {
                e = true;
                let g = this.ld == null ? 0 : this.ld._inner[0];
                let h = this.ld == null ? this.k4.count - 1 : this.ld._inner[this.k4.count - 1];
                c = this.k4.item(g);
                d = this.k4.item(h);
                this.k8 = false;
                if (this.categoryMode == 2) {
                    let i = this.ly(c, d);
                    if (+c != +(dateMinValue())) {
                        c = dateSubtract(+c, +i);
                    }
                    d = dateAdd(+d, +i);
                }
            }
        }
        if (this.lb()) {
            e = true;
            c = this.minimumValue;
        }
        if (this.la()) {
            e = true;
            d = this.maximumValue;
        }
        let j = +(this.actualMinimumValue) != +c || +(this.actualMaximumValue) != +d;
        if (e && j) {
            let k = this.actualMinimumValue;
            let l = this.actualMaximumValue;
            this.actualMinimumValue = c;
            this.actualMaximumValue = d;
            this.l5();
        }
    }
    l5() {
    }
    get k4() {
        return this.k3;
    }
    set k4(a) {
        if (this.k3 != a) {
            let b = this.k3;
            this.k3 = a;
            this.g5("DateTimeColumn", b, this.k3);
        }
    }
    get ld() {
        return this.lc;
    }
    set ld(a) {
        this.lc = a;
    }
    get i$b() {
        if (this.ld == null) {
            let a = typeCast(FastItemDateTimeColumn.$, this.k4);
            if (a != null) {
                this.l1();
            }
            else {
                this.ld = null;
            }
        }
        return this.ld;
    }
    l1() {
        if (this.k9) {
            this.ld = new List$1(Number_$type, 0);
            let a = this.ld;
            let b = this.k4.count;
            for (let c = 0; c < b; c++) {
                a.add(c);
            }
        }
        else {
            let d = typeCast(FastItemDateTimeColumn.$, this.k4);
            this.ld = d.h();
        }
    }
    i$e(a, b, c, d) {
        return this.ln(a, b, c, d);
    }
    ln(a, b, c, d) {
        if (b.isEmpty) {
            return -1;
        }
        let e = d;
        let f = new ScalerParams(0, a, b, this.ca, c);
        let g, h;
        if (this.ca) {
            h = this.d1(e.left, f);
            g = this.d1(e.right, f);
        }
        else {
            g = this.d1(e.left, f);
            h = this.d1(e.right, f);
        }
        let i = Math.max(dateMinValue().getTime(), Math.min(dateMaxValue().getTime(), truncate(g)));
        return this.lm(dateFromTicks(i));
    }
    lm(a) {
        if (this.k4 == null || this.ld.count != this.k4.count) {
            return -1;
        }
        for (let b = 0; b < this.ld.count; b++) {
            let c = this.k4.item(this.ld._inner[b]);
            if (c >= a) {
                return Math.max(b - 1, 0);
            }
        }
        return this.ld.count - 1;
    }
    i$g(a, b, c, d) {
        return this.lq(a, b, c, d);
    }
    lq(a, b, c, d) {
        if (b.isEmpty) {
            return -1;
        }
        let e = d;
        let f = new ScalerParams(0, a, b, this.ca, c);
        let g, h;
        if (this.ca) {
            h = this.d1(e.left, f);
            g = this.d1(e.right, f);
        }
        else {
            g = this.d1(e.left, f);
            h = this.d1(e.right, f);
        }
        let i = Math.max(dateMinValue().getTime(), Math.min(dateMaxValue().getTime(), truncate(h)));
        return this.lp(dateFromTicks(i));
    }
    lp(a) {
        if (this.k4 == null || this.ld.count != this.k4.count) {
            return -1;
        }
        for (let b = this.ld.count - 1; b >= 0; b--) {
            let c = this.ld._inner[b];
            let d = this.k4.item(c);
            if (d < a) {
                return b == this.ld.count - 1 ? b : b + 1;
            }
        }
        return 0;
    }
    i$d(a) {
        if (this.k4 == null) {
            return NaN;
        }
        let b = this.k3.item(a);
        let c = b.getTime();
        let d = c;
        return d;
    }
    i$c(a) {
        let b = this;
        if (b.i$b == null) {
            return -1;
        }
        let c = new SortedListView$1(Date_$type, this.k4, b.i$b);
        let ticks_ = a;
        let d = (new Date(ticks_));
        let e = this.lo(d, c);
        if (e >= 0 && e < b.i$b.count && e - 1 >= 0 && e - 1 < b.i$b.count) {
            let diff1_ = d.getTime() - c.item(e - 1).getTime();
            let diff2_ = c.item(e).getTime() - d.getTime();
            let f = e - 1;
            let g = e;
            if (f < 0 && g >= 0) {
                return g;
            }
            if (g > b.i$b.count - 1 && f < b.i$b.count) {
                return f;
            }
            if (f < 0 && g < 0) {
                return -1;
            }
            if (f > b.i$b.count - 1 && g > b.i$b.count - 1) {
                return -1;
            }
            let h = diff1_ / (diff1_ + diff2_);
            if (isNaN_(h)) {
                h = 0;
            }
            return f + h;
        }
        if (e >= 0 && e < b.i$b.count) {
            return e;
        }
        let i = this.i3();
        if (e == b.i$b.count && this.bh != null && this.dy(a, new ScalerParams(0, this.bh.mr, this.i8, this.ca, i)) < (this.i8.right + 2)) {
            return e - 1;
        }
        if (e == -1 && this.bh != null && Math.abs(this.dy(a, new ScalerParams(0, this.bh.mr, this.i8, this.ca, i)) - this.i8.left) < 2) {
            return 0;
        }
        return -1;
    }
    lo(a, b) {
        let c = this;
        if (this.k4 == null || c.i$b == null) {
            return -1;
        }
        let d = -1;
        let e = ArrayExtension.binarySearch$11(Date_$type, b, (f) => {
            if (a < f) {
                return -1;
            }
            if (a > f) {
                return 1;
            }
            return 0;
        });
        if (e >= 0) {
            d = e;
        }
        else {
            d = ~e;
        }
        while (d >= 0 && d < b.count && d - 1 >= 0 && +(b.item(d)) == +(b.item(d - 1))) {
            d--;
        }
        return d;
    }
    i$f(a) {
        let b = this;
        if (b.i$b == null || this.k4 == null || b.i$b.count != this.k4.count) {
            return -1;
        }
        let c = new SortedListView$1(Date_$type, this.k4, b.i$b);
        let ticks_ = a;
        let d = (new Date(ticks_));
        let e = this.lo(d, c);
        let f = this.i3();
        if (e >= 0 && e < b.i$b.count && e - 1 >= 0 && e - 1 < b.i$b.count) {
            let g = +d - +(c.item(e - 1));
            let h = +(c.item(e)) - +d;
            if (g < h) {
                e = e - 1;
            }
        }
        if (e >= 0 && e < b.i$b.count) {
            return b.i$b._inner[e];
        }
        if (e == b.i$b.count && this.bh != null && this.dy(a, new ScalerParams(0, this.bh.mr, this.i8, this.ca, f)) < (this.i8.right + 2)) {
            return e - 1;
        }
        if (e == -1 && this.bh != null && Math.abs(this.dy(a, new ScalerParams(0, this.bh.mr, this.i8, this.ca, f)) - this.i8.left) < 2) {
            return 0;
        }
        return -1;
    }
    i$i() {
        this.ld = null;
        this.ha();
    }
    get_k8() {
        return this.k7;
    }
    set_k8(a) {
        this.k7 = a;
    }
    get k8() {
        return this.get_k8();
    }
    set k8(a) {
        this.set_k8(a);
    }
    g1(a) {
        super.g1(a);
        this.dateTimeMemberPath = a;
    }
    g4(a) {
        super.g4(a);
        this.minimumValue = a;
    }
    g3(a) {
        super.g4(a);
        this.maximumValue = a;
    }
    cp() {
        if (this.ci && this.cq) {
            this.ba = this.a9();
        }
        let a = this.actualMinimumValue.getTime();
        let b = this.actualMaximumValue.getTime();
        this.l0();
        let c = !this.lb() ? this.actualMinimumValue.getTime() : this.minimumValue.getTime();
        let d = !this.la() ? this.actualMaximumValue.getTime() : this.maximumValue.getTime();
        let e = new AxisRangeChangedEventArgs(0, a, c, b, d);
        this.g6(e);
        return true;
    }
    lb() {
        if (+(this.minimumValue) == +(dateMinValue())) {
            return false;
        }
        return (this.minimumValue != null);
    }
    la() {
        if (+(this.maximumValue) == +(dateMaxValue())) {
            return false;
        }
        return (this.maximumValue != null);
    }
    get actualMinimumValue() {
        return this.lf;
    }
    set actualMinimumValue(a) {
        let b = +(this.lf) != +a;
        if (b) {
            let c = this.lf;
            this.lf = a;
            this.g5("ActualMinimumValue", c, a);
        }
    }
    fb() {
        return this.actualMinimumValue;
    }
    get actualMaximumValue() {
        return this.le;
    }
    set actualMaximumValue(a) {
        let b = +(this.le) != +a;
        if (b) {
            let c = this.le;
            this.le = a;
            this.g5("ActualMaximumValue", c, a);
        }
    }
    fa() {
        return this.maximumValue;
    }
    l2(a) {
        this.hc(a);
        if (this.jm == null) {
            return;
        }
        for (let b of fromEnum(this.cw())) {
            b.je(a);
        }
    }
    gz(a, b, c, d) {
        super.gz(a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                let e = typeCast(IFastItemsSource_$type, c);
                if (e != null) {
                    e.deregisterColumn(this.k4);
                    this.k4 = null;
                    e.event = delegateRemove(e.event, runOn(this, this.lz));
                }
                let f = typeCast(IFastItemsSource_$type, d);
                if (f != null) {
                    this.ld = null;
                    this.k4 = this.k5(this.dateTimeMemberPath);
                    f.event = delegateCombine(f.event, runOn(this, this.lz));
                }
                this.l2(false);
                break;
            case TimeAxisBase.$$p[0]:
                if (this.jm != null) {
                    this.jm.deregisterColumn(this.k4);
                    this.k4 = this.k5(this.dateTimeMemberPath);
                    this.ld = null;
                }
                break;
            case TimeAxisBase.$$p[3]:
                this.cn();
                this.l2(false);
                break;
            case TimeAxisBase.$$p[2]:
                this.cn();
                this.l2(false);
                break;
            case "DateTimeColumn":
                this.l0();
                break;
        }
    }
    lz(a, b) {
        this.ld = null;
    }
    k5(a) {
        return TimeAxisBase.k6(a, this);
    }
    static k6(a, b) {
        if (a == null) {
            return b.jm.registerColumnDateTime(null, null, false);
        }
        let c = null;
        let d = SeriesViewer.bb(a, b.coercionMethods);
        c = d.a;
        return b.jm.registerColumnDateTime(a, c, b.expectFunctions);
    }
    at() {
        if (this.cr) {
            return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
        }
        else {
            return new HorizontalAxisLabelPanel();
        }
    }
    get_a0() {
        return 0;
    }
    get a0() {
        return this.get_a0();
    }
    hc(a) {
        super.hc(a);
        let b = this.a3.ay();
        let c = this.a3.a1();
        let d = this.a3.az();
        let e = this.a3.a0();
        let f = this.a3.e();
        let g = this.a3.f();
        let h = this.a3.g();
        this.hj();
        this.gn(b);
        this.gn(c);
        this.gn(d);
        this.gn(e);
        this.cx.clear();
        this.cy.clear();
        this.jt.clear();
        this.au.ac = this;
        let i = this.bh != null ? this.bh.mr : Rect.empty;
        let j = !i.isEmpty ? this.i8 : Rect.empty;
        this.au.cp = i;
        this.au.co = j;
        if (i.isEmpty || j.isEmpty) {
            this.bq.count = 0;
            this.bp.count = 0;
            this.bo.count = 0;
        }
        if (this.bq.count == 0) {
            this.au.ab.clear();
        }
        if (this.ax != null) {
            this.ax.registerAxis(this);
        }
        this.l0();
    }
    get_b7() {
        return true;
    }
    startCursor() {
    }
    resetCursor() {
    }
    StartTimeCursor() {
        this.startCursor();
    }
    ResetTimeCursor() {
        this.resetCursor();
    }
    getCategorySize(a, b, c) {
        if (this.j5 == 0) {
            return 0;
        }
        let d = this.i6(b, c);
        return d.width / (this.j5 * a.width);
    }
    getGroupCenter(a, b, c, d) {
        return this.getCategorySize(b, c, d) * 0.5;
    }
    jy(a, b, c) {
        let d = !isNaN_(this.jv) ? MathUtil.b(this.jv, 0, 1) : 0;
        let e = 1 - 0.5 * d;
        let f = this.getCategorySize(a, b, c) * e;
        return f;
    }
    get_cf() {
        return true;
    }
    ly(a, b) {
        return (0);
    }
    preferredCategoryMode(a) {
        return this.b5 ? 0 : 1;
    }
    get isVertical() {
        return this.ch;
    }
    j$c(a, b) {
        return this.d1.apply(this, arguments);
    }
    j$b(a, b) {
        return this.dy.apply(this, arguments);
    }
    j$d(a, b, c, d, e) {
        this.gr.apply(this, arguments);
    }
    j$e(a, b, c, d) {
        this.gs.apply(this, arguments);
    }
    j$f(a, b, c, d) {
        this.gt.apply(this, arguments);
    }
    get j$a() {
        return this.ca;
    }
    get i$a() {
        return this.b7;
    }
}
TimeAxisBase.$t = markType(TimeAxisBase, 'TimeAxisBase', CategoryAxisBase.$, [ISortingAxis_$type, IDateTimeAxis_$type]);
TimeAxisBase.$$p = markDep(DependencyProperty, PropertyMetadata, TimeAxisBase, 'g5', ['DateTimeMemberPath::l6', [2, null], 'IsDataPreSorted:k9:l7', [0, false], 'MaximumValue::l8', [3, null], 'MinimumValue::l9', [3, null]]);
//# sourceMappingURL=TimeAxisBase.js.map