/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { FastItemDateTimeColumn } from "igniteui-angular-core";
import { CategoryXAxis } from "./CategoryXAxis";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { TimeAxisLabelFormatCollection } from "./TimeAxisLabelFormatCollection";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { EventArgs, runOn, delegateCombine, typeCast, Date_$type, markType } from "igniteui-angular-core";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { TimeAxisBase } from "./TimeAxisBase";
import { TimeXAxis } from "./TimeXAxis";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { truncate } from "igniteui-angular-core";
import { dateMaxValue, dateMinValue } from "igniteui-angular-core";
/**
 * @hidden
 */
var OrdinalTimeXAxis = /** @class */ (function (_super) {
    tslib_1.__extends(OrdinalTimeXAxis, _super);
    function OrdinalTimeXAxis() {
        var _this = _super.call(this) || this;
        _this.lw = dateMaxValue();
        _this.lv = dateMinValue();
        _this.l0 = dateMaxValue();
        _this.lz = dateMinValue();
        _this.l5 = null;
        _this.lt = null;
        _this.lr = null;
        _this.mc = 0;
        _this.ly = dateMinValue();
        _this.lx = dateMaxValue();
        _this.visibleRangeChanged = null;
        FastItemDateTimeColumn.o();
        _this.lr = new TimeAxisLabelFormatCollection();
        var a = _this.ls;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(_this, _this.me));
        _this.li = 0;
        return _this;
    }
    OrdinalTimeXAxis.prototype.d0 = function (a, b, c) {
        return this.dy(a, new ScalerParams(0, b, c, this.ca, this.i3()));
    };
    OrdinalTimeXAxis.prototype.dz = function (a, b, c) {
        return this.dy(a, b);
    };
    OrdinalTimeXAxis.prototype.dy = function (a, b) {
        var c = this.lh;
        var d = this.li;
        var e = this.lh - this.li;
        var f = e >= 1 ? (a - d) / (c - d) : e == 0 ? 0.5 : NaN;
        if (this.cb) {
            f = 1 - f;
        }
        var g = b.d;
        var h = b.e;
        return g.left + g.width * (f - h.left) / h.width;
    };
    OrdinalTimeXAxis.prototype.gr = function (a, b, c, d, e) {
        var f = this.k3(a);
        var g = f != null;
        for (var h = 0; h < b.count; h++) {
            for (var i = c; i < d; i++) {
                var j = g ? f[i] : a.item(i);
                j[h] = this.dy(j[h], e);
            }
        }
    };
    OrdinalTimeXAxis.prototype.gs = function (a, b, c, d) {
        for (var e = b; e < c; e++) {
            a.item(e, this.dy(a.item(e), d));
        }
    };
    OrdinalTimeXAxis.prototype.d3 = function (a, b, c) {
        return this.d1(a, new ScalerParams(0, b, this.i8, this.ca, this.i3()));
    };
    OrdinalTimeXAxis.prototype.getUnscaledValue3 = function (a, b, c, d) {
        return this.d1(a, new ScalerParams(0, b, this.i8, this.ca, this.i3()));
    };
    OrdinalTimeXAxis.prototype.d1 = function (a, b) {
        var c = b.e;
        var d = b.d;
        var e = c.left + (a - d.left) * c.width / d.width;
        if (this.cb) {
            e = 1 - e;
        }
        return this.li + e * (this.lh - this.li);
    };
    OrdinalTimeXAxis.prototype.d2 = function (a, b, c) {
        return this.d1(a, b);
    };
    OrdinalTimeXAxis.prototype.gt = function (a, b, c, d) {
        for (var e = b; e < c; e++) {
            a.item(e, this.d1(a.item(e), d));
        }
    };
    OrdinalTimeXAxis.prototype.gz = function (a, b, c, d) {
        _super.prototype.gz.call(this, a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                var e = typeCast(IFastItemsSource_$type, c);
                if (e != null) {
                    e.deregisterColumn(this.lu);
                    this.lu = null;
                }
                if (this.jm != null) {
                    this.lu = TimeAxisBase.k6(this.dateTimeMemberPath, this);
                }
                break;
            case "DateTimeMemberPath":
                if (this.jm != null) {
                    this.jm.deregisterColumn(this.lu);
                    this.lu = TimeAxisBase.k6(this.dateTimeMemberPath, this);
                }
                break;
            case "DateTimeColumn":
                this.cn();
                this.mc = this.mb();
                break;
            case "MinimumValue":
            case "MaximumValue":
                this.cn();
                this.ha();
                break;
        }
    };
    Object.defineProperty(OrdinalTimeXAxis.prototype, "actualMinimumValue", {
        get: function () {
            return this.lw;
        },
        set: function (a) {
            this.lw = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OrdinalTimeXAxis.prototype, "actualMaximumValue", {
        get: function () {
            return this.lv;
        },
        set: function (a) {
            this.lv = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OrdinalTimeXAxis.prototype, "visibleMinimum", {
        get: function () {
            return this.l0;
        },
        set: function (a) {
            this.l0 = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OrdinalTimeXAxis.prototype, "visibleMaximum", {
        get: function () {
            return this.lz;
        },
        set: function (a) {
            this.lz = a;
        },
        enumerable: true,
        configurable: true
    });
    OrdinalTimeXAxis.prototype.mf = function () {
        if (this.lu == null || this.lu.count == 0 || this.lu.count < this.li - 1) {
            this.actualMinimumValue = dateMinValue();
            this.actualMaximumValue = dateMaxValue();
            return;
        }
        var a = Math.max(0, Math.min(this.li, this.lu.count - 1));
        var b = Math.max(0, Math.min(this.lh, this.lu.count - 1));
        var c = +(this.actualMinimumValue) != +(this.lu.item(a)) || +(this.actualMaximumValue) != +(this.lu.item(b));
        if (c) {
            var d = this.actualMinimumValue;
            var e = this.actualMaximumValue;
            this.actualMinimumValue = this.lu.item(a);
            this.actualMaximumValue = this.lu.item(b);
            this.mg();
        }
    };
    OrdinalTimeXAxis.prototype.mg = function () {
        if (this.lu == null || this.lu.count == 0 || this.bh == null) {
            var a = +(this.visibleMinimum) != +(this.actualMinimumValue) || +(this.visibleMaximum) != +(this.actualMaximumValue);
            this.visibleMinimum = this.actualMinimumValue;
            this.visibleMaximum = this.actualMaximumValue;
            if (a && this.visibleRangeChanged != null) {
                this.visibleRangeChanged(this, EventArgs.empty);
            }
            return;
        }
        var b = new ScalerParams(1, this.bh.m6, this.bh.m5, this.ca);
        var c = truncate(Math.ceil(this.d1(this.bh.m5.left, b)));
        var d = truncate(Math.ceil(this.d1(this.bh.m5.right, b)));
        var e = c >= 0 && c < this.lu.count ? this.lu.item(c) : this.actualMinimumValue;
        var f = d >= 0 && d < this.lu.count ? this.lu.item(d) : this.actualMaximumValue;
        var g = +(this.visibleMinimum) != +e || +(this.visibleMaximum) != +f;
        this.visibleMinimum = e;
        this.visibleMaximum = f;
        if (g && this.visibleRangeChanged != null) {
            this.visibleRangeChanged(this, EventArgs.empty);
        }
    };
    Object.defineProperty(OrdinalTimeXAxis.prototype, "dateTimeMemberPath", {
        get: function () {
            return this.l5;
        },
        set: function (a) {
            var b = this.dateTimeMemberPath;
            if (a != b) {
                this.l5 = a;
                this.g5("DateTimeMemberPath", b, this.dateTimeMemberPath);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OrdinalTimeXAxis.prototype, "lu", {
        get: function () {
            return this.lt;
        },
        set: function (a) {
            if (this.lt != a) {
                var b = this.lt;
                this.lt = a;
                this.g5("DateTimeColumn", b, this.lt);
            }
        },
        enumerable: true,
        configurable: true
    });
    OrdinalTimeXAxis.prototype.hn = function (a, b) {
        _super.prototype.hn.call(this, a, b);
        this.mg();
    };
    OrdinalTimeXAxis.prototype.getWindowRectForSelection = function (a, b) {
        if (this.lu == null) {
            return Rect.empty;
        }
        var c = a > b;
        var d = c ? b : a;
        var e = c ? a : b;
        var f = -1;
        while (++f < this.lu.count && this.lu.item(f) < d) {
            ;
        }
        var g = this.lu.count;
        while (--g >= 0 && this.lu.item(g) > e) {
            ;
        }
        var h = new ScalerParams(0, new Rect(0, 0, 0, 1, 1), new Rect(0, 0, 0, 1, 1), this.ca, this.bh.mv);
        var i = this.dy(f, h);
        var j = this.dy(g + 1, h);
        return new Rect(0, i, NaN, Math.max(0, j - i), NaN);
    };
    Object.defineProperty(OrdinalTimeXAxis.prototype, "ls", {
        get: function () {
            return this.lr;
        },
        enumerable: true,
        configurable: true
    });
    OrdinalTimeXAxis.prototype.me = function (a, b) {
        this.hb(false);
    };
    OrdinalTimeXAxis.prototype.g1 = function (a) {
        _super.prototype.g1.call(this, a);
        this.dateTimeMemberPath = a;
    };
    OrdinalTimeXAxis.prototype.e8 = function (a) {
        if (this.as != null) {
            return this.as(a);
        }
        if (this.bf != null) {
            return this.bf.i(a);
        }
        if (!(typeCast(Date_$type, a) !== null)) {
            return _super.prototype.e8.call(this, a);
        }
        var b = TimeXAxis.mu(a, this.md, this.ls, this.et);
        return b == null ? _super.prototype.e8.call(this, a) : b;
    };
    OrdinalTimeXAxis.prototype.fl = function (a) {
        var b = 0;
        if (this.categoryMode == 0) {
            b = truncate(Math.round(a));
        }
        else {
            b = truncate(Math.floor(a));
        }
        if (b < 0 || b > this.j6 - 1) {
            return _super.prototype.fl.call(this, a);
        }
        var c = this.lu.item(b);
        var d = this.e8(c);
        if (d == null) {
            return null;
        }
        return d.toString();
    };
    Object.defineProperty(OrdinalTimeXAxis.prototype, "md", {
        get: function () {
            return +(this.visibleMaximum) - +(this.visibleMinimum);
        },
        enumerable: true,
        configurable: true
    });
    OrdinalTimeXAxis.prototype.k5 = function () {
        return this.lu;
    };
    OrdinalTimeXAxis.prototype.hm = function (a, b) {
        _super.prototype.hm.call(this, a, b);
        this.mg();
    };
    OrdinalTimeXAxis.prototype.lb = function (a, b) {
        var c = this.categoryMode == 0 ? 0 : 0.5;
        return _super.prototype.lb.call(this, a + c, b);
    };
    OrdinalTimeXAxis.prototype.la = function (a, b, c, d) {
        return b;
    };
    OrdinalTimeXAxis.prototype.mb = function () {
        var _this = this;
        if (this.lu == null || this.lu.count < 2) {
            return (0);
        }
        return TimeXAxis.m2(function (a) { return _this.lu.item(a); }, this.lu.count);
    };
    OrdinalTimeXAxis.prototype.itemLabelFormat = function () {
        return TimeXAxis.mz(this.mc);
    };
    Object.defineProperty(OrdinalTimeXAxis.prototype, "minimumValue", {
        get: function () {
            return this.ly;
        },
        set: function (a) {
            var b = this.minimumValue;
            if (+a != +b) {
                this.ly = a;
                this.gz(this, "MinimumValue", b, this.minimumValue);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OrdinalTimeXAxis.prototype, "maximumValue", {
        get: function () {
            return this.lx;
        },
        set: function (a) {
            var b = this.maximumValue;
            if (+a != +b) {
                this.lx = a;
                this.gz(this, "MaximumValue", b, this.maximumValue);
            }
        },
        enumerable: true,
        configurable: true
    });
    OrdinalTimeXAxis.prototype.cp = function () {
        if (+(this.minimumValue) == +(dateMaxValue()) || +(this.maximumValue) == +(dateMinValue())) {
            return _super.prototype.cp.call(this);
        }
        if (this.ci && this.cq) {
            this.ba = this.a9();
        }
        if (this.jm == null || this.lu == null) {
            return false;
        }
        var a = this.li;
        if (+(this.minimumValue) != +(dateMinValue())) {
            var b = -1;
            while (b++ <= this.lu.count) {
                if (this.lu.item(b) >= this.minimumValue) {
                    break;
                }
            }
            a = b;
        }
        var c = this.categoryMode == 0 ? this.jm.count - 1 : this.jm.count;
        if (+(this.maximumValue) != +(dateMaxValue())) {
            var d = this.jm.count;
            while (d-- > 0) {
                if (this.lu.item(d) <= this.maximumValue) {
                    break;
                }
            }
            c = d;
        }
        if (a != this.li || c != this.lh) {
            var e = new AxisRangeChangedEventArgs(0, this.li, a, this.lh, c);
            this.li = a;
            this.lh = c;
            this.g6(e);
            this.mf();
            this.ki();
            return true;
        }
        return false;
    };
    OrdinalTimeXAxis.prototype.kr = function (a) {
        _super.prototype.kr.call(this, a);
        this.co(true);
    };
    Object.defineProperty(OrdinalTimeXAxis.prototype, "isVertical", {
        get: function () {
            return this.ch;
        },
        enumerable: true,
        configurable: true
    });
    OrdinalTimeXAxis.prototype.j$c = function (a, b) {
        return this.d1.apply(this, arguments);
    };
    OrdinalTimeXAxis.prototype.j$b = function (a, b) {
        return this.dy.apply(this, arguments);
    };
    OrdinalTimeXAxis.prototype.j$d = function (a, b, c, d, e) {
        this.gr.apply(this, arguments);
    };
    OrdinalTimeXAxis.prototype.j$e = function (a, b, c, d) {
        this.gs.apply(this, arguments);
    };
    OrdinalTimeXAxis.prototype.j$f = function (a, b, c, d) {
        this.gt.apply(this, arguments);
    };
    Object.defineProperty(OrdinalTimeXAxis.prototype, "j$a", {
        get: function () {
            return this.ca;
        },
        enumerable: true,
        configurable: true
    });
    OrdinalTimeXAxis.$t = markType(OrdinalTimeXAxis, 'OrdinalTimeXAxis', CategoryXAxis.$, [ITimeRangeSelectorAxis_$type]);
    return OrdinalTimeXAxis;
}(CategoryXAxis));
export { OrdinalTimeXAxis };
//# sourceMappingURL=OrdinalTimeXAxis.js.map