/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Base, markType, runOn, EnumUtil, typeCast, fromEnum, markDep } from "igniteui-angular-core";
import { IBucketizer_$type } from "./IBucketizer";
import { NotImplementedException } from "igniteui-angular-core";
import { CategoryAngleAxis } from "./CategoryAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { truncate } from "igniteui-angular-core";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { SeriesRenderer$2 } from "./SeriesRenderer$2";
import { RadialFrame } from "./RadialFrame";
import { DependencyProperty } from "igniteui-angular-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { ScalerParams } from "./ScalerParams";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { RadialAxes } from "./RadialAxes";
import { Visibility_$type } from "igniteui-angular-core";
import { SeriesRenderingArguments } from "./SeriesRenderingArguments";
import { PropertyMetadata } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
/**
 * @hidden
 */
var RadialBucketCalculator = /** @class */ (function (_super) {
    tslib_1.__extends(RadialBucketCalculator, _super);
    function RadialBucketCalculator(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.c = 0;
        _this.d = 0;
        _this.b = 0;
        _this.a = a;
        return _this;
    }
    RadialBucketCalculator.prototype.getBucket = function (a) {
        throw new NotImplementedException(0);
    };
    RadialBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        return this.getBucket(a);
    };
    RadialBucketCalculator.prototype.getErrorBucket = function (a, b) {
        return NaN;
    };
    RadialBucketCalculator.prototype.getBucketInfo = function (a, b, c, d) {
        a = this.c;
        b = this.d;
        c = this.b;
        d = this.a.cn.eu;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    };
    RadialBucketCalculator.prototype.e = function (a) {
        var b = this.a.bs;
        var c = this.a.br;
        var d = this.a.cn.m4;
        if (b.isEmpty || c.isEmpty || d == null || this.a.cn.bz == null || this.a.cn.bz.count == 0) {
            this.b = 0;
            return;
        }
        var e = Math.floor(d.lk(c, b));
        var f = Math.ceil(d.lj(c, b));
        if (d.ca) {
            f = Math.ceil(d.lk(c, b));
            e = Math.floor(d.lj(c, b));
        }
        if (f < e) {
            f = d.j5 + f;
        }
        var g = this.a.cn.m6;
        var h = g != null ? g.lq : 0.75;
        var i = Math.min(c.width, c.height) * 0.5 * (h) * 2 * Math.PI;
        var j = Math.floor((f - e + 1) * a / i);
        this.b = truncate(Math.max(1, j));
        this.c = truncate(Math.max(0, Math.floor(e / this.b) - 1));
        this.d = truncate(Math.ceil(f / this.b));
    };
    RadialBucketCalculator.prototype.cacheValues = function () {
    };
    RadialBucketCalculator.prototype.unCacheValues = function () {
    };
    RadialBucketCalculator.$t = markType(RadialBucketCalculator, 'RadialBucketCalculator', Base.$, [IBucketizer_$type]);
    return RadialBucketCalculator;
}(Base));
export { RadialBucketCalculator };
/**
 * @hidden
 */
var RadialBase = /** @class */ (function (_super) {
    tslib_1.__extends(RadialBase, _super);
    function RadialBase() {
        var _this = _super.call(this) || this;
        _this.nc = null;
        _this.na = new RadialFrame(3);
        _this.nb = new RadialFrame(3);
        _this.m9 = new RadialFrame(3);
        _this.m7 = null;
        _this.nc = new SeriesRenderer$2(RadialFrame.$, RadialBaseView.$, 1, runOn(_this, _this.no), runOn(_this, _this.np), runOn(_this, _this.ca), runOn(_this, _this.jm), runOn(_this, _this.nn), function (a) { return _this.m8.co.e(_this.eu); });
        return _this;
    }
    RadialBase.prototype.iv = function (a) {
        _super.prototype.iv.call(this, a);
        this.m8 = a;
    };
    RadialBase.prototype.nn = function () {
        if (this.bt.g) {
            this.bt.t();
        }
    };
    Object.defineProperty(RadialBase.prototype, "categoryAxis", {
        get: function () {
            return this.m4;
        },
        enumerable: true,
        configurable: true
    });
    RadialBase.prototype.ap = function () {
        return this.m4;
    };
    RadialBase.prototype.ng = function (a) {
        var _this = this;
        if (!this.hasMarkers) {
            return false;
        }
        var b = this.m4;
        var c = new ScalerParams(1, this.bs.mr, this.lz, b.ca);
        c.c = this.getEffectiveViewport1(this.bi);
        var d = this.m6;
        var e = new ScalerParams(1, this.bs.mr, this.lz, d.ca);
        e.c = this.getEffectiveViewport1(this.bi);
        a.clear();
        this.l1.cc(function (f) {
            if (f._visibility == 0) {
                var g = new SeriesPointOfInterest();
                var h = f.n;
                var i = f.o;
                if (h < _this.lz.left || h > _this.lz.right || i < _this.lz.top || i > _this.lz.bottom) {
                    return;
                }
                g.b = b.d1(h, c);
                g.c = d.d1(i, e);
                g.d = b.fl(f.ak);
                g.a = f.content;
                a.add(g);
            }
        });
        return true;
    };
    RadialBase.prototype.get_c2 = function () {
        return true;
    };
    RadialBase.prototype.ag = function () {
        return [this.m4, this.m6];
    };
    RadialBase.prototype.ju = function (a, b) {
        this.m8.co.e(this.eu);
        this.je(false);
    };
    RadialBase.prototype.jt = function (a, b) {
        this.m8.co.e(this.eu);
        this.je(false);
    };
    RadialBase.prototype.i0 = function (a, b, c, d) {
        _super.prototype.i0.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                if (c != null && d == null) {
                    if (this.m4 != null) {
                        this.m4.bx(this);
                    }
                    if (this.m6 != null) {
                        this.m6.bx(this);
                    }
                }
                if (c == null && d != null) {
                    if (this.m4 != null) {
                        this.m4.ck(this);
                    }
                    if (this.m6 != null) {
                        this.m6.ck(this);
                    }
                }
                this.m8.co.e(this.eu);
                this.je(false);
                break;
            case RadialBase.$$p[0]:
                if (this.m4 != null && this.m6 != null) {
                    this.m7 = new RadialAxes(this.m6, this.m4);
                }
                if (c != null) {
                    c.bx(this);
                }
                if (d != null) {
                    d.ck(this);
                }
                this.m8.co.e(this.eu);
                this.je(false);
                break;
            case RadialBase.$$p[2]:
                if (this.m4 != null && this.m6 != null) {
                    this.m7 = new RadialAxes(this.m6, this.m4);
                }
                if (c != null) {
                    c.bx(this);
                }
                if (d != null) {
                    d.ck(this);
                }
                this.m8.co.e(this.eu);
                if (this.m6 == null || !this.m6.cn()) {
                    this.je(false);
                }
                break;
            case "SyncLink":
                if (this.bn != null && this.bs != null) {
                    this.m8.co.e(this.eu);
                    this.je(false);
                }
                break;
            case "TransitionProgress":
                this.nb.c(this.ez, this.na, this.m9);
                if (this.cc(this.bi)) {
                    return;
                }
                if (this.ez == 1) {
                    this.np(this.m9, this.m8);
                }
                else {
                    this.np(this.nb, this.m8);
                }
                if (this.bs != null) {
                    this.bs.jk(this);
                }
                break;
            case RadialBase.$$p[1]:
                this.je(false);
                this.il();
                break;
            case "VisibilityProxy":
                if (EnumUtil.getEnumValue(Visibility_$type, c) != 0 && EnumUtil.getEnumValue(Visibility_$type, d) == 0) {
                    this.m8.co.e(this.eu);
                }
                break;
        }
    };
    RadialBase.prototype.ne = function (a) {
        if (typeCast(NumericRadiusAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    RadialBase.prototype.nd = function (a) {
        if (typeCast(CategoryAngleAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    RadialBase.prototype.fp = function (a) {
        var b = this.e8(a);
        return b >= 0 && this.bz != null && b < this.bz.count ? this.bz.item(b) : null;
    };
    RadialBase.prototype.nh = function (a) {
        var b = this.bi.bs;
        var c = this.bi.br;
        if (this.m4 != null && !b.isEmpty && !c.isEmpty && this.m7 != null) {
            var d = this.m7.c(a);
            if (d < 0) {
                d += Math.PI * 2;
            }
            if (d > Math.PI * 2) {
                d -= Math.PI * 2;
            }
            return d;
        }
        return NaN;
    };
    RadialBase.prototype.ni = function (a) {
        var b = this.bi.bs;
        var c = this.bi.br;
        var d = -1;
        if (this.m4 != null && !b.isEmpty && !c.isEmpty && this.m7 != null) {
            var e = this.m7.c(a);
            if (e < 0) {
                e += Math.PI * 2;
            }
            if (e > Math.PI * 2) {
                e -= Math.PI * 2;
            }
            var f = this.m4.getUnscaledAngle(e);
            if (this.m4.categoryMode != 0) {
                f -= 0.5;
            }
            d = f;
        }
        return d;
    };
    RadialBase.prototype.e8 = function (a) {
        var b = truncate(Math.round(this.ni(a)));
        if (this.bz != null && b == this.bz.count) {
            b = 0;
        }
        return b;
    };
    RadialBase.prototype.c9 = function (a) {
        return false;
    };
    RadialBase.prototype.ic = function () {
        _super.prototype.ic.call(this);
        if (this.m4 != null) {
            this.m4.hb(false);
        }
        if (this.m6 != null) {
            this.m6.hb(false);
        }
    };
    RadialBase.prototype.dw = function (a, b, c) {
        var d = true;
        var e = c;
        if (!_super.prototype.dw.call(this, a, b, c) || !c.l() || b.isEmpty || a.isEmpty || this.m4 == null || this.m4.itemsSource == null || this.m6 == null || this.m7 == null || this.bz == null || this.m4.bh == null || this.m6.bh == null || this.m6.kb == this.m6.ka) {
            e.co.b = 0;
            d = false;
        }
        return d;
    };
    RadialBase.prototype.jf = function (a) {
        var b;
        var c;
        var d = this.getViewInfo(c, b);
        c = d.p0;
        b = d.p1;
        if (!this.dw(c, b, this.bi)) {
            this.hw(true, this.bi);
            return;
        }
        var e = new SeriesRenderingArguments(this, c, b, a, this.de);
        var f = this.nc.g(e, this.na, this.m9, this.nb, this.m8);
        this.na = f.p1;
        this.m9 = f.p2;
        this.nb = f.p3;
    };
    RadialBase.prototype.nj = function () {
        var e_1, _a;
        var a = 0;
        try {
            for (var _b = tslib_1.__values(fromEnum(this.bs.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                if (b == this) {
                    return a;
                }
                var c = typeCast(RadialBase.$, b);
                if (c != null && c.m4 == this.m4 && c.preferredCategoryMode(c.m4) == 2) {
                    a++;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return -1;
    };
    RadialBase.$t = markType(RadialBase, 'RadialBase', MarkerSeries.$, [IHasCategoryModePreference_$type]);
    RadialBase.$$p = markDep(DependencyProperty, PropertyMetadata, RadialBase, 'raisePropertyChanged', ['AngleAxis:m4:nq', [CategoryAngleAxis.$, null], 'ClipSeriesToBounds:nf:nr', [0, false], 'ValueAxis:m6:ns', [NumericRadiusAxis.$, null]]);
    return RadialBase;
}(MarkerSeries));
export { RadialBase };
/**
 * @hidden
 */
var RadialBaseView = /** @class */ (function (_super) {
    tslib_1.__extends(RadialBaseView, _super);
    function RadialBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.co = null;
        _this.cn = null;
        _this.cp = null;
        _this.cq = 0;
        _this.cr = null;
        _this.cn = a;
        _this.cp = new Pool$1(Marker.$);
        _this.cf(_this.cp);
        return _this;
    }
    RadialBaseView.prototype.cc = function (a) {
        this.cp.c(a);
    };
    RadialBaseView.$t = markType(RadialBaseView, 'RadialBaseView', MarkerSeriesView.$);
    return RadialBaseView;
}(MarkerSeriesView));
export { RadialBaseView };
//# sourceMappingURL=RadialBucketCalculator_combined.js.map