import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
import { Point, Type, IList$1 } from "igniteui-angular-core";
import { AxisLabelPanelBaseView } from "./AxisLabelPanelBaseView";
import { Rect } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { List$1 } from "igniteui-angular-core";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { IAngleScaler } from "./IAngleScaler";
import { CategoryAxisRenderer } from "./CategoryAxisRenderer";
import { DependencyProperty } from "igniteui-angular-core";
import { AxisOrientation } from "./AxisOrientation";
import { AxisView } from "./AxisView";
import { PolarAxisRenderingManager } from "./PolarAxisRenderingManager";
import { ScalerParams } from "./ScalerParams";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { Geometry } from "igniteui-angular-core";
import { NumericAxisBase } from "./NumericAxisBase";
import { NumericAxisRenderer } from "./NumericAxisRenderer";
import { NumericAxisRenderingParameters } from "./NumericAxisRenderingParameters";
import { GeometryGroup } from "igniteui-angular-core";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
import { NumericAxisBaseView } from "./NumericAxisBaseView";
/**
 * @hidden
 */
export declare class AngleAxisLabelPanel extends AxisLabelPanelBase {
    static $t: Type;
    ad(): AxisLabelPanelBaseView;
    b8(a: AxisLabelPanelBaseView): void;
    cs: AngleAxisLabelPanelView;
    constructor();
    ct: boolean;
    cz: (arg1: number) => Point;
    ao(a: number, b: Rect): boolean;
    cx: number;
    cu: number;
    cw: number;
    cv: number;
    ay(): List$1<Rect>;
    private cy;
    ah(): AxisLabelsLocation;
    as(a: AxisLabelsLocation): boolean;
}
/**
 * @hidden
 */
export declare class CategoryAngleAxis extends CategoryAxisBase implements IAngleScaler {
    static $t: Type;
    a2(): AxisView;
    gx(a: AxisView): void;
    k4: CategoryAngleAxisView;
    protected get_b2(): boolean;
    private k9;
    constructor();
    at(): AxisLabelPanelBase;
    k6: CategoryAxisRenderer;
    private la;
    private lo;
    private le;
    private k5;
    private l3;
    private li;
    private k3;
    getMinMaxAngle(a: Rect, b: number, c: number): {
        p1: number;
        p2: number;
    };
    ac(): void;
    private k7;
    k8: NumericRadiusAxis;
    ai(): Axis;
    lp: number;
    private lf;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    jy(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    ll(a: number): number;
    protected hc(a: boolean): void;
    lk(a: Rect, b: Rect): number;
    lj(a: Rect, b: Rect): number;
    getScaledAngle(a: number): number;
    getUnscaledAngle(a: number): number;
    dy(a: number, b: ScalerParams): number;
    d1(a: number, b: ScalerParams): number;
    protected gz(a: any, b: string, c: any, d: any): void;
    private lx;
    lz(a: NumericRadiusAxis): void;
    static readonly l0: DependencyProperty;
    lm: number;
    private lc;
    lg: number;
    d9(): number;
    static readonly l1: DependencyProperty;
    ln: number;
    private ld;
    lh: number;
    protected lb(): boolean;
    protected get_a0(): AxisOrientation;
    readonly a0: AxisOrientation;
    cp(): boolean;
    private lq;
    lr: number;
    i0(a: number, b: Rect, c: Rect, d?: any, e?: any): Geometry;
    readonly isVertical: boolean;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    readonly j$a: boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class NumericAngleAxis extends NumericAxisBase implements IAngleScaler {
    static $t: Type;
    a2(): AxisView;
    gx(a: AxisView): void;
    lj: NumericAngleAxisView;
    lm: PolarAxisRenderingManager;
    protected get_b2(): boolean;
    constructor();
    at(): AxisLabelPanelBase;
    private lq;
    private ls;
    private ln;
    private lo;
    jk(): NumericAxisRenderer;
    private lz;
    dy(a: number, b: ScalerParams): number;
    getScaledAngle1(a: number, b: boolean, c: boolean): number;
    getScaledAngle(a: number): number;
    d1(a: number, b: ScalerParams): number;
    getUnscaledAngle(a: number): number;
    lt: number;
    private lp;
    protected gz(a: any, b: string, c: any, d: any): void;
    private lv;
    jo(): NumericAxisRenderingParameters;
    jn(a: Rect, b: Rect, c: Rect, d: Rect): NumericAxisRenderingParameters;
    getMinMaxAngle(a: Rect, b: number, c: number): {
        p1: number;
        p2: number;
    };
    protected hc(a: boolean): void;
    private lk;
    ll: NumericRadiusAxis;
    ai(): Axis;
    lx(a: NumericRadiusAxis): void;
    protected hm(a: Rect, b: Rect): void;
    protected get_a0(): AxisOrientation;
    readonly a0: AxisOrientation;
    i0(a: number, b: Rect, c: Rect, d?: any, e?: any): Geometry;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class NumericRadiusAxis extends NumericAxisBase {
    static $t: Type;
    a2(): AxisView;
    gx(a: AxisView): void;
    ll: NumericRadiusAxisView;
    protected get_ce(): boolean;
    dx(): number;
    private lu;
    private lt;
    private lm;
    constructor();
    at(): AxisLabelPanelBase;
    ln: boolean;
    private lr;
    private lo;
    jk(): NumericAxisRenderer;
    dy(a: number, b: ScalerParams): number;
    lx(a: number, b: boolean, c: boolean, d: number, e: number): number;
    lw(a: number): number;
    ly(a: number): number;
    d1(a: number, b: ScalerParams): number;
    l0: number;
    lq: number;
    lz: number;
    lp: number;
    protected gz(a: any, b: string, c: any, d: any): void;
    protected ls: number;
    l5(a: Axis): void;
    private lj;
    lk: Axis;
    ai(): Axis;
    jo(): NumericAxisRenderingParameters;
    jn(a: Rect, b: Rect, c: Rect, d: Rect): NumericAxisRenderingParameters;
    private l6;
    private l1;
    lv(): number;
    k9(a: AxisRangeChangedEventArgs): void;
    protected hc(a: boolean): void;
    protected hm(a: Rect, b: Rect): void;
    l4(a: GeometryGroup, b: Rect, c: Rect, d: Rect, e: Rect): void;
    protected get_a0(): AxisOrientation;
    readonly a0: AxisOrientation;
    i0(a: number, b: Rect, c: Rect, d?: any, e?: any): Geometry;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AngleAxisLabelPanelView extends AxisLabelPanelBaseView {
    static $t: Type;
    protected ax: AngleAxisLabelPanel;
    constructor(a: AngleAxisLabelPanel);
    am(): void;
    ay(a: List$1<Rect>, b: List$1<boolean>): void;
    o(): number;
    p(): number;
    q(): number;
    r(): number;
}
/**
 * @hidden
 */
export declare class CategoryAngleAxisView extends CategoryAxisBaseView {
    static $t: Type;
    protected bg: CategoryAngleAxis;
    constructor(a: CategoryAngleAxis);
}
/**
 * @hidden
 */
export declare class NumericAngleAxisView extends NumericAxisBaseView {
    static $t: Type;
    protected bg: NumericAngleAxis;
    constructor(a: NumericAngleAxis);
}
/**
 * @hidden
 */
export declare class NumericRadiusAxisView extends NumericAxisBaseView {
    static $t: Type;
    protected bg: NumericRadiusAxis;
    constructor(a: NumericRadiusAxis);
}
