import { MarkerSeries } from "./MarkerSeries";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { ScatterAxisInfoCache } from "./ScatterAxisInfoCache";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-angular-core";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { TrendLineType } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { CollisionAvoidanceType } from "./CollisionAvoidanceType";
import { Axis } from "./Axis";
import { ScatterErrorBarSettings } from "./ScatterErrorBarSettings";
import { ScatterFrame } from "./ScatterFrame";
import { SeriesView } from "./SeriesView";
import { Point, Type } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Rect } from "igniteui-angular-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { Clipper } from "igniteui-angular-core";
import { OwnedPoint } from "./OwnedPoint";
import { AxisRange } from "./AxisRange";
import { MarkerManagerBase } from "./MarkerManagerBase";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { ErrorBarsHelper } from "./ErrorBarsHelper";
import { IErrorBarCalculator } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { RenderSurface } from "./RenderSurface";
import { IDictionary$2 } from "igniteui-angular-core";
import { HashPool$2 } from "igniteui-angular-core";
import { Size } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class ScatterBase extends MarkerSeries implements ISupportsErrorBars, ITrendLineSeries {
    static $t: Type;
    protected bf(): SeriesView;
    hu(): void;
    iv(a: SeriesView): void;
    m9: ScatterBaseView;
    protected get_c4(): boolean;
    ag(): Axis[];
    fs(a: any, b: string): any;
    ch(a: List$1<SeriesPointOfInterest>, b: boolean, c: number): boolean;
    protected bd(): SeriesHitTestMode;
    lx(a: Point): Rect;
    dh(a: Point, b: boolean): boolean;
    constructor();
    m8: ScatterAxisInfoCache;
    xAxis: NumericXAxis;
    yAxis: NumericYAxis;
    nv: string;
    nh: IFastItemColumn$1<number>;
    private ng;
    nz: string;
    nj: IFastItemColumn$1<number>;
    private ni;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    ow: Brush;
    static readonly oh: DependencyProperty;
    trendLineThickness: number;
    oy: PenLineCap;
    ox: DoubleCollection;
    trendLinePeriod: number;
    m5: CollisionAvoidanceType;
    readonly GetErrorBarsXAxis: Axis;
    readonly GetErrorBarsYAxis: Axis;
    np: number;
    no: number;
    ic(): void;
    na: ScatterErrorBarSettings;
    protected i0(a: any, b: string, c: any, d: any): void;
    nl(a: any): boolean;
    nk(a: any): boolean;
    private og;
    private oz;
    private o0;
    private n1;
    protected nm(a: string, b: FastItemsSourceEventAction): boolean;
    protected hz(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    n9(a: ScatterFrame): void;
    oa(a: ScatterFrame, b: Clipper): void;
    an(a: Axis): AxisRange;
    fp(a: Point): any;
    e8(a: Point): number;
    c9(a: any): boolean;
    protected jt(a: Rect, b: Rect): void;
    protected ju(a: Rect, b: Rect): void;
    nd: ScatterFrame;
    nf: ScatterFrame;
    nc: ScatterFrame;
    n2(a: ScatterBaseView, b: ScatterFrame, c: number, d: Rect, e: Rect): void;
    n6(a: ScatterFrame, b: ScatterBaseView): void;
    hw(a: boolean, b: SeriesView): void;
    of(a: ScatterFrame, b: ScatterBaseView): void;
    n4(a: ScatterFrame, b: ScatterBaseView): void;
    n7(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    n5(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    n3(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: any, e: number, f: number, g: boolean): {
        p4?: number;
        p5?: number;
    };
    n8(a: ErrorBarsHelper, b: IErrorBarCalculator, c: number, d: number, e: number, f: boolean): {
        p2?: number;
        p3?: number;
        p4?: number;
    };
    oc(a: ScatterFrame, b: ScatterBaseView): void;
    private od;
    private oe;
    dw(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    jf(a: boolean): void;
    protected jp(): void;
    ne: ScatterFrame;
    jg(a: Rect, b: RenderSurface): void;
    private nb;
    jd(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    ob(a: IDictionary$2<any, OwnedPoint>, b: HashPool$2<any, Marker>): void;
    m4(a: ScatterBaseView, b: HashPool$2<any, Marker>, c: Point[], d: Rect, e: Rect): Point[];
    nn(a: HashPool$2<any, Marker>, b: List$1<number>): List$1<number>;
    protected h5(a: any): void;
    eh(): number;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ScatterBaseView extends MarkerSeriesView {
    static $t: Type;
    cr: MarkerManagerBase;
    protected cp: Point[];
    protected cs: ScatterBase;
    protected cx: List$1<number>;
    constructor(a: ScatterBase);
    private c7;
    private c8;
    ct: ScatterTrendLineManager;
    ap(): void;
    private c6;
    c9(a: Marker): Size;
    protected cq(): MarkerManagerBase;
    protected c4(a: IDictionary$2<any, OwnedPoint>): void;
    cw(): List$1<Marker>;
    co(): Point[];
    protected cn(): Point[];
    protected cv(): List$1<number>;
    cy(): void;
    c2(a: PathGeometry): void;
    cz(): void;
    c3(a: PathGeometry): void;
    c5(): void;
    cu: HashPool$2<any, Marker>;
    cc(a: (arg1: Marker) => void): void;
    c1(): void;
    protected a2(a: RenderingContext, b: boolean): void;
    c0(a: boolean): void;
    getDefaultTooltipTemplate(): string;
}
