import { Control } from "igniteui-angular-core";
import { INotifyPropertyChanged, Type, Base, Point, EventArgs, PropertyChangedEventArgs, IEnumerable, IEnumerable$1, IList$1 } from "igniteui-angular-core";
import { ILegendOwner } from "igniteui-angular-core";
import { IInternalLegendOwner } from "igniteui-angular-core";
import { ISeriesViewerWidget } from "./ISeriesViewerWidget";
import { SRProvider } from "igniteui-angular-core";
import { DoubleAnimator } from "igniteui-angular-core";
import { IChartLegend } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { DependencyObject } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { ChartHitTestMode } from "./ChartHitTestMode";
import { InteractionState } from "igniteui-angular-core";
import { WindowResponse } from "./WindowResponse";
import { Visibility } from "igniteui-angular-core";
import { IOverviewPlusDetailPane } from "igniteui-angular-core";
import { SeriesViewerComponentsFromView } from "./SeriesViewerComponentsFromView";
import { Brush } from "igniteui-angular-core";
import { ModifierKeys } from "igniteui-angular-core";
import { DataTemplate } from "igniteui-angular-core";
import { HorizontalAlignment } from "igniteui-angular-core";
import { CanvasRenderScheduler } from "igniteui-angular-core";
import { SyncSettings } from "./SyncSettings";
import { CultureInfo } from "igniteui-angular-core";
import { SeriesViewerComponentsForView } from "./SeriesViewerComponentsForView";
import { Dictionary$2 } from "igniteui-angular-core";
import { PropertyUpdatedEventArgs } from "igniteui-angular-core";
import { NotifyCollectionChangedEventArgs } from "igniteui-angular-core";
import { ObservableCollection$1 } from "igniteui-angular-core";
import { Size } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { FrameworkElement } from "igniteui-angular-core";
import { MouseEventArgs } from "igniteui-angular-core";
import { MouseButtonEventArgs } from "igniteui-angular-core";
import { Key } from "igniteui-angular-core";
import { EventProxy } from "igniteui-angular-core";
import { RectChangedEventArgs } from "igniteui-angular-core";
import { RefreshCompletedEventArgs } from "./RefreshCompletedEventArgs";
import { Thickness } from "igniteui-angular-core";
import { AxisTitlePosition } from "./AxisTitlePosition";
import { FontInfo } from "igniteui-angular-core";
import { IFastItemsSource } from "igniteui-angular-core";
import { CoercionInfo } from "./CoercionInfo";
import { ChartContentType } from "./ChartContentType";
import { ISchedulableRender } from "igniteui-angular-core";
import { Rectangle } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { Line } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
import { TextBlock } from "igniteui-angular-core";
import { ITileZoomTile } from "./ITileZoomTile";
import { RenderSurface } from "./RenderSurface";
import { PathGeometry } from "igniteui-angular-core";
import { Geometry } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { LabelPanelsArrangeState } from "./LabelPanelsArrangeState";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
import { IProvidesViewport } from "./IProvidesViewport";
import { DomRenderer, DomWrapper } from "igniteui-angular-core";
import { PointerTooltipStyle } from "./PointerTooltipStyle";
import { BrushCollection } from "igniteui-angular-core";
import { DefaultPaletteInfo } from "./DefaultPaletteInfo";
import { AxisRange } from "./AxisRange";
import { AxisAnnotationCollection } from "./AxisAnnotationCollection";
import { VerticalAlignment } from "igniteui-angular-core";
import { Canvas } from "igniteui-angular-core";
import { IFastItemsSourceProvider } from "igniteui-angular-core";
import { AxisExtentType } from "./AxisExtentType";
import { DoubleCollection } from "igniteui-angular-core";
import { LabelPosition } from "./LabelPosition";
import { BindingFormatter } from "igniteui-angular-core";
import { LabelFontHeuristics } from "./LabelFontHeuristics";
import { AxisOrientation } from "./AxisOrientation";
import { Pool$1 } from "igniteui-angular-core";
import { AxisComponentsFromView } from "./AxisComponentsFromView";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { GeometryCollection } from "igniteui-angular-core";
import { PathRenderingInfo } from "./PathRenderingInfo";
import { RenderRequestedEventArgs } from "./RenderRequestedEventArgs";
import { ScalerParams } from "./ScalerParams";
import { CategoryMode } from "./CategoryMode";
import { GridMode } from "./GridMode";
import { Panel } from "igniteui-angular-core";
import { UIElement } from "igniteui-angular-core";
import { TickmarkValues } from "./TickmarkValues";
import { ICategoryScaler } from "./ICategoryScaler";
import { FastItemsSourceEventArgs } from "igniteui-angular-core";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { NumericAxisRenderingParameters } from "./NumericAxisRenderingParameters";
import { AxisRenderingParametersBase } from "./AxisRenderingParametersBase";
import { HighlightingState } from "./HighlightingState";
import { Marker } from "./Marker";
import { Polyline } from "igniteui-angular-core";
import { ContentControl } from "igniteui-angular-core";
import { Polygon } from "igniteui-angular-core";
import { ILegendSeries } from "igniteui-angular-core";
import { ILegendTemplateProvider } from "igniteui-angular-core";
import { StandardLegendItems } from "igniteui-angular-core";
import { StandardLegendBadges } from "igniteui-angular-core";
import { PenLineCap } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { SeriesComponentsForView } from "./SeriesComponentsForView";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { SeriesComponentsFromView } from "./SeriesComponentsFromView";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { ISortingAxis } from "./ISortingAxis";
import { MarkerType } from "./MarkerType";
import { Style } from "igniteui-angular-core";
import { HashPool$2 } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class SeriesViewer extends Control implements INotifyPropertyChanged, ILegendOwner, IInternalLegendOwner {
    static $t: Type;
    private _widget;
    widget: ISeriesViewerWidget;
    bn: SeriesViewerView;
    static staticInit(): void;
    private by;
    private readonly bz;
    private a0;
    readonly a1: ISeriesViewerInteractionManager;
    readonly cv: boolean;
    constructor();
    private bh;
    hr(): void;
    private ja;
    hs(): void;
    readonly series: SeriesCollection;
    private a3;
    private j3;
    private _skipDataCleanup;
    skipDataCleanup: boolean;
    protected jx(a: any): void;
    private j4;
    hv(a: number, b: number, c: boolean, d: boolean): {
        p0?: number;
        p1?: number;
    };
    cl(): boolean;
    protected readonly cs: boolean;
    readonly az: IHighlightingManager;
    bo: DoubleAnimator;
    private hq;
    kf(a: number): void;
    hp(): void;
    l7(a: number): Brush;
    md(a: number): Brush;
    mb(a: number): Brush;
    mc(a: number): Brush;
    al: ChartContentManager;
    mj: Point;
    private mi;
    readonly cu: boolean;
    legend: IChartLegend;
    static readonly lb: DependencyProperty;
    cd: boolean;
    static readonly k0: DependencyProperty;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected ji(a: string, b: any, c: any): void;
    ij(): void;
    ik(a: IEnumerable): void;
    iu(a: Series, b: any, c: any): void;
    iy(a: Series, b: any, c: any): void;
    iv(a: Series, b: any, c: any): void;
    iw(a: Series, b: any, c: any): void;
    ix(a: Series, b: any, c: any): void;
    iz(a: Series, b: any, c: any): void;
    i0(a: Series, b: any, c: any): void;
    seriesCursorMouseMove: (sender: any, e: ChartCursorEventArgs) => void;
    jl(a: Series, b: any): void;
    seriesMouseLeftButtonDown: (sender: any, e: DataChartMouseButtonEventArgs) => void;
    jp(a: Series, b: any, c: MouseButtonEventArgs): void;
    seriesMouseLeftButtonUp: (sender: any, e: DataChartMouseButtonEventArgs) => void;
    jq(a: Series, b: any, c: MouseButtonEventArgs): void;
    seriesMouseMove: (sender: any, e: ChartMouseEventArgs) => void;
    jr(a: Series, b: any, c: MouseEventArgs): void;
    seriesMouseEnter: (sender: any, e: ChartMouseEventArgs) => void;
    jn(a: Series, b: any, c: MouseEventArgs): void;
    seriesMouseLeave: (sender: any, e: ChartMouseEventArgs) => void;
    jo(a: Series, b: any, c: MouseEventArgs): void;
    private mq;
    protected get_m5(): Rect;
    readonly m5: Rect;
    private mo;
    mv: Rect;
    m0(a: Rect, b: Rect, c: Rect): Rect;
    private b1;
    private mn;
    protected get_mu(): Rect;
    readonly mu: Rect;
    my(a: Rect, b: Rect, c: Rect): Rect;
    protected mt(a: Rect): Rect;
    mz(): Rect;
    protected kb(a: Axis): void;
    m6: Rect;
    dj: boolean;
    cb: boolean;
    db: boolean;
    e6: number;
    private ez;
    e2: number;
    e5: number;
    jd(a: Rect, b: Rect): void;
    private a5;
    a6(): SeriesViewerComponentsForView;
    cy: boolean;
    private an;
    ap: ChartHitTestMode;
    jt(): void;
    protected aq(): ChartHitTestMode;
    private am;
    ao: ChartHitTestMode;
    cz: boolean;
    seriesAnimating: (series: Series) => void;
    jk(a: Series): void;
    abstract c3(): boolean;
    abstract c4(): boolean;
    c2(): boolean;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    bg: InteractionState;
    private b3;
    private bf;
    im(a: Point): void;
    io(a: Point): void;
    c9(a: Point, b: number): boolean;
    ib(a: Point): void;
    c8(a: Key): boolean;
    private b7;
    ch: boolean;
    private b2;
    ce: boolean;
    protected get_cw(): boolean;
    readonly cw: boolean;
    id(a: Point): void;
    readonly ck: boolean;
    g1: string;
    is(a: Point): void;
    ie(a: Point, b: boolean): void;
    ic(a: Point): void;
    da: boolean;
    private i8;
    ir(a: Point): void;
    i9(a: Point, b: number, c: number, d: number): void;
    iq(a: number): void;
    i5(a: Point, b: number, c: number, d: number): void;
    il(a: Point): void;
    ip(a: number): void;
    ig(a: Point): void;
    i4(a: Point, b: number, c: number, d: number): void;
    ii(a: Size): void;
    ho(): void;
    h8(a: Point, b: boolean): void;
    bd(a: boolean): InteractionState;
    i7(): void;
    i6(): void;
    j8(): void;
    hk(): void;
    hf(): void;
    he(): void;
    jb(): void;
    jw(): void;
    ju(): void;
    h7(a: Point, b: boolean): void;
    private b8;
    df: boolean;
    h6(a: Point, b: boolean): void;
    kk(a: any, b: PropertyUpdatedEventArgs): void;
    kj(a: SyncLink, b: SyncLink): void;
    hg(a: Point): void;
    km(a: Rect, b: boolean): void;
    kn(a: Rect, b: boolean, c: boolean): void;
    jc(a: Rect, b: boolean): void;
    readonly c0: boolean;
    private _dm;
    dm(): IEnumerable$1<SeriesViewer>;
    ml(a: Point): Point;
    m4(a: Rect): Rect;
    windowRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private js;
    i3(a: Rect, b: Rect): void;
    sizeChanged: (sender: any, e: RectChangedEventArgs) => void;
    i1(a: Size, b: Size): void;
    cn: boolean;
    dc(a: Rect, b: Rect): boolean;
    actualWindowRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private jg;
    j2(): void;
    gridAreaRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private jh;
    protected get_cx(): boolean;
    readonly cx: boolean;
    it(a: Rect, b: Rect): void;
    ba: WindowResponse;
    cj: boolean;
    ex: number;
    private _syncChannel;
    syncChannel: string;
    private a7;
    actualSyncLink: SyncLink;
    hu(): void;
    na: Visibility;
    readonly bi: IOverviewPlusDetailPane;
    protected kg(a: boolean): void;
    m9: Visibility;
    cm: boolean;
    di: boolean;
    mf: Brush;
    l5: Brush;
    me: Brush;
    cg(): boolean;
    cc(): boolean;
    private e1;
    private notifyCrosshairUpdate;
    protected kl(a: number, b: number): void;
    eg(): number;
    eh(): number;
    protected je(a: any, b: string, c: any, d: any): void;
    ki(): void;
    protected h4(): void;
    kh(): void;
    private b9;
    protected dg: boolean;
    bc: InteractionState;
    be: InteractionState;
    l1: ModifierKeys;
    l2: ModifierKeys;
    private mp;
    m1: Rect;
    dn: Date;
    dk: boolean;
    protected ka(): void;
    ha(): void;
    ev: number;
    ew: number;
    private m3;
    refreshCompleted: (sender: any, e: RefreshCompletedEventArgs) => void;
    jj(): void;
    protected abstract bm(): SeriesViewerView;
    protected i2(a: SeriesViewerView): void;
    static m2: Rect;
    ko: DataTemplate;
    kx: DataTemplate;
    ku: DataTemplate;
    kv: DataTemplate;
    kp: DataTemplate;
    ks: DataTemplate;
    kq: DataTemplate;
    kw: DataTemplate;
    kt: DataTemplate;
    kr: DataTemplate;
    gr: string;
    l0: HorizontalAlignment;
    lz: HorizontalAlignment;
    private fc;
    gy: string;
    private fb;
    gm: string;
    private l4;
    mh: Brush;
    private l3;
    mg: Brush;
    private d7;
    et: number;
    private d5;
    er: number;
    private d6;
    es: number;
    private d4;
    eq: number;
    private d3;
    ep: number;
    private d1;
    en: number;
    private d2;
    eo: number;
    private d0;
    em: number;
    gf: string;
    m7(): Thickness;
    m8(): Thickness;
    aj(a: Axis): AxisTitlePosition;
    ak(a: Axis): AxisTitlePosition;
    abstract getFontInfo(): FontInfo;
    getFontHeight(): number;
    abstract getFontBrush(): Brush;
    abstract l6(): Brush;
    e9: any;
    provideContainer(a: any): void;
    h9(a: number, b: number): void;
    notifyContainerResized(): void;
    mw(): Rect;
    hl(): void;
    mk(): Point;
    bq(): FontInfo;
    bp(): FontInfo;
    l8(): Brush;
    l9(): Brush;
    hc(a: Series): void;
    jy(a: Series): void;
    ah: CanvasRenderScheduler;
    ai: CanvasRenderScheduler;
    ag: CanvasRenderScheduler;
    private b6;
    c7: boolean;
    private b0;
    ca: boolean;
    private _syncSettings;
    syncSettings: SyncSettings;
    hb(a: any): void;
    j0(a: any): void;
    h1(source_: any, a: number, b: any, c: any): void;
    hw(source_: any): void;
    hz(source_: any, a: number, b: any): void;
    h0(source_: any, a: number, b: any): void;
    destroyed: boolean;
    protected e7: any;
    protected dl: Dictionary$2<string, any>;
    c6: boolean;
    destroy(): void;
    protected hj(): void;
    j7(source_: any): void;
    j1(): void;
    j6(a: string, source_: any): void;
    jz(a: string, b: boolean): void;
    protected j5(a: Series, b: any): void;
    protected kd(a: any): void;
    protected ke(): void;
    private d8;
    eu: number;
    private dx;
    ej: number;
    private dz;
    el: number;
    private dv;
    ef: number;
    private du;
    ee: number;
    private dt;
    ed: number;
    dd(): boolean;
    private b4;
    cp: boolean;
    private dy;
    ek: number;
    private dw;
    ei: number;
    static bb(a: string, b: any): CoercionInfo;
    private fa;
    f2: string;
    private dq;
    ea: number;
    private dp;
    d9: number;
    private mm;
    mr: Rect;
    mx(): Rect;
    private ht;
    protected ms(): Rect;
    e8(a: number, b: number): any;
    private dr;
    eb: number;
    private ds;
    ec: number;
    h3(): void;
    h2(): void;
    flush(): void;
    hn(a: boolean, b: boolean): void;
    dh(): boolean;
    private ky;
    private ar;
    protected jv(a: DependencyObject, b: (arg1: boolean) => void): void;
    protected j9(a: DependencyObject): void;
    hh(): void;
    cq: boolean;
    cr: boolean;
    co: boolean;
    ih(): void;
    private b5;
    readonly c1: boolean;
    hd(): void;
    c5(): boolean;
    private e0;
    e4(): number;
    bt(): FontInfo;
    bs(): FontInfo;
    kc(): void;
    protected cf: boolean;
    ct: boolean;
    seriesDataUpdated: (sender: any, e: EventArgs) => void;
    jm(): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class SeriesViewerView extends Base implements ISchedulableRender {
    static $t: Type;
    constructor(a: SeriesViewer);
    ci(): void;
    n: SeriesViewer;
    cy(): void;
    private ch;
    a: CanvasRenderScheduler;
    l: IOverviewPlusDetailPane;
    private dg;
    private df;
    ef(): void;
    private cn;
    private cm;
    m: OverviewPlusDetailViewportHost;
    b5(a: number, b: number, c: RenderSurface): void;
    dy(): void;
    b7(): void;
    d0(): void;
    ce(): void;
    b6(): void;
    b8(): void;
    dr(a: Series): void;
    c5(): void;
    ao(a: Series): boolean;
    protected f: SeriesCollection;
    protected b: AxisCollection;
    private ag;
    as: boolean;
    bn(a: Series): void;
    dl(a: RenderingContext): void;
    bv(): void;
    br(): void;
    b9(): void;
    b4(): void;
    dj(): void;
    protected e8: Rectangle;
    protected e7: Path;
    d1(): void;
    d9(a: Rect): void;
    bu(): void;
    c8(): void;
    eh(a: number, b: number, c: number, d: number): void;
    protected e6: Line;
    protected e5: Line;
    d6(): void;
    cf(): void;
    ea(a: number, b: number, c: number, d: number): void;
    d2(): void;
    ca(): void;
    cd(): void;
    private ey;
    private ez;
    eg(a: Rect, b: Rect): void;
    d5(): void;
    ei(a: Rect): void;
    dp(a: Axis): void;
    dq(a: Axis): void;
    bm(a: Axis): void;
    bj(a: Axis): void;
    private g;
    h(): SeriesViewerComponentsFromView;
    static au(a: Series): List$1<Series>;
    dv(): void;
    i: SeriesViewerViewManager;
    protected u: RenderingContext;
    x: RenderingContext;
    w: RenderingContext;
    protected v: RenderingContext;
    al: boolean;
    am: boolean;
    protected bg: any;
    cu(a: any): void;
    private aj;
    protected cs(a: Point, b: boolean): void;
    protected ct(a: Point, b: boolean): void;
    protected cx(a: Point): void;
    protected cr(a: Point, b: boolean): void;
    dm(a: RenderingContext): void;
    protected get_an(): boolean;
    readonly an: boolean;
    j: EventProxy;
    d8(): void;
    a7: number;
    e(a: Point, b: boolean, c: DataContext, d: boolean): {
        ret: Series;
        p2: DataContext;
    };
    bb(): number;
    ba(): number;
    a6: number;
    a5: number;
    private e1;
    private ah;
    co(): void;
    cv(a: number, b: number): void;
    dw(): void;
    private az;
    private ax;
    private ay;
    private aw;
    private ai;
    private y;
    private b0;
    private ed;
    t(): FontInfo;
    s(): FontInfo;
    private ex;
    private ew;
    private bd;
    private a0;
    private bc;
    fc(): Thickness;
    fb(): Thickness;
    protected dn(a: Rect): void;
    ck(): void;
    private e2;
    protected dt(): void;
    isValid(): boolean;
    preRender(): void;
    protected dk(): void;
    protected z: boolean;
    protected du(): void;
    cw(): void;
    cq(): void;
    e3(): Rect;
    e0(): Point;
    private dz;
    d7(): void;
    dh(): void;
    protected aq(a: Point): boolean;
    c2(a: Point, b: boolean, c: boolean): void;
    protected c1(a: Point): void;
    protected c0(a: Point): void;
    protected c3(a: Point): void;
    dx(): void;
    readonly er: ModifierKeys;
    ej(a: Rect): void;
    cl(a: boolean): void;
    bi(a: boolean): void;
    protected ee(): void;
    private ad;
    isDirty: boolean;
    undirty(a: boolean): void;
    readonly index: number;
    postRender(): void;
    b3(): void;
    protected ac: boolean;
    cb(): void;
    d3(): void;
    bt(a: boolean): void;
    bk(a: any): void;
    eb(a: number): void;
    ec(a: number): void;
    bl(a: any): void;
    ds(a: any): void;
    c4(a: Brush): void;
    bs(a: Point): void;
    at: boolean;
    k(a: boolean): InteractionState;
    cz(): void;
    private el;
    private ek;
    a9(a: TextBlock, b: FontInfo): number;
    a8(a: string, b: FontInfo): number;
    dc(): void;
    private em;
    db(): void;
    c7(): void;
    c(a: Axis): AxisTitlePosition;
    d(a: Axis): AxisTitlePosition;
    dd(): void;
    de(): void;
    r(): FontInfo;
    ev(): Brush;
    o(): FontInfo;
    es(): Brush;
    q(): FontInfo;
    p(): FontInfo;
    eu(): Brush;
    et(): Brush;
    readonly a2: number;
    readonly a3: number;
    readonly a4: number;
    readonly a1: number;
    readonly eo: TextBlock;
    readonly en: TextBlock;
    e4(): Rect;
    fa(): Thickness;
    e9(): Thickness;
    private ab;
    private aa;
    c6(a: any, b: any): void;
    da(a: any, b: any): void;
    eq(): HorizontalAlignment;
    ep(): HorizontalAlignment;
    private ae;
    bo(): void;
    ak(): boolean;
    b2(): void;
    cj(): void;
    ar(a: Point): boolean;
    di(): void;
    private av;
    b1(a: Dictionary$2<any, ITileZoomTile>, b: List$1<ITileZoomTile>, c: number): void;
    bf(a: Rect, b: ITileZoomTile, c: number): any;
    by(): void;
    bz(a: ITileZoomTile): void;
    cg(): void;
    ap: boolean;
    private be;
    bw(): void;
    bp(): void;
    bx(a: number): void;
    bq(): void;
    private af;
    cc(): void;
    d4(): void;
    c9(): void;
    cp(): void;
    bh(a: number, b: number): any;
}
/**
 * @hidden
 */
export declare class OverviewPlusDetailViewportHost extends Base implements IProvidesViewport {
    static $t: Type;
    constructor(a: SeriesViewerView);
    a: SeriesViewerView;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    getEffectiveViewport(): Rect;
}
/**
 * @hidden
 */
export declare class SeriesViewerViewManager extends Base {
    static $t: Type;
    ae: DomRenderer;
    protected af: DomWrapper;
    protected aj: DomWrapper;
    protected ai: DomWrapper;
    protected ag: DomWrapper;
    ak: DomWrapper;
    t: RenderingContext;
    w: RenderingContext;
    v: RenderingContext;
    u: RenderingContext;
    x: RenderingContext;
    f: EventProxy;
    private j;
    constructor(a: SeriesViewerView);
    protected ah: DomWrapper;
    bi(): void;
    bf(a: any): void;
    static bx(a: DomRenderer, b: () => void): void;
    private bh;
    a9(): void;
    g(): IOverviewPlusDetailPane;
    bl(): void;
    bm(): void;
    b2(): Brush;
    private ab;
    private aa;
    private ac;
    ay(a: number, b: number, c: number): void;
    b7(): Point;
    y(): boolean;
    bb(a: boolean): void;
    a7(a: BrushCollection, b: BrushCollection, c: Brush, d: FontInfo, e: Brush): {
        p0: BrushCollection;
        p1: BrushCollection;
        p2: Brush;
        p3: FontInfo;
        p4: Brush;
    };
    e(): DefaultPaletteInfo;
    a6(a: number, b: number[], c: Brush, d: Brush, e: number, f: boolean): {
        p0: number;
        p1: number[];
        p2: Brush;
        p3: Brush;
        p4: number;
        p5: boolean;
    };
    ax(): void;
    bt(x_: number): void;
    private ad;
    bu(y_: number): void;
    at(a: any): void;
    a8(): void;
    bn(): void;
    au(a: any): void;
    bj(a: any): void;
    bc(): void;
    private l;
    p(): FontInfo;
    private b9;
    cd(): Thickness;
    private aq;
    as(): string;
    private ap;
    ar(): string;
    private b8;
    cc(): Thickness;
    private bz;
    b4(): Brush;
    private by;
    b3(): Brush;
    private k;
    o(): FontInfo;
    private a;
    c(): AxisTitlePosition;
    private b;
    d(): AxisTitlePosition;
    private n;
    r(): FontInfo;
    private b1;
    b6(): Brush;
    private m;
    q(): FontInfo;
    private b0;
    b5(): Brush;
    private ca;
    ce(): Thickness;
    private cb;
    cf(): Thickness;
    bo(): void;
    private bw;
    private bq;
    private bp;
    private br;
    private bs;
    a5(a: number, b: number): void;
    private h;
    i(): PointerTooltipStyle;
    ba(a: boolean): void;
    private z;
    an(a: Rect, b: ITileZoomTile, c: number): any;
    a2(a: ITileZoomTile): void;
    a1(): void;
    bk(a: List$1<ITileZoomTile>): void;
    private al;
    az(): void;
    av(): void;
    private am;
    a0(a: number): void;
    aw(): void;
    private s;
    bd(): void;
    bv(a: boolean): void;
    a3(): void;
    a4(): void;
    bg(): void;
    be(): void;
    ao(a: number, b: number): any;
}
/**
 * @hidden
 */
export declare class AutoRangeCalculator extends Base {
    static $t: Type;
    static a(a: NumericAxisBase, b: number, c: number, d: boolean, e: number, f: number, g: number): {
        p5: number;
        p6: number;
    };
}
/**
 * @hidden
 */
export interface IAxisAnnotationManager {
    owner: Axis;
    onAutoAnnotionsChanged(a: Axis, b: AxisAnnotationCollection, c: NotifyCollectionChangedEventArgs): void;
    onAutoAnnotionsReset(a: Axis, b: AxisAnnotationCollection, c: EventArgs): void;
    onAnnotionsChanged(a: Axis, b: AxisAnnotationCollection, c: NotifyCollectionChangedEventArgs): void;
    onAnnotionsReset(a: Axis, b: AxisAnnotationCollection, c: EventArgs): void;
    onAddAnnotations(a: Axis): void;
    arrangeAnnotations(a: Axis, b: AxisLabelPanelBaseView, c: List$1<FrameworkElement>, d: List$1<Rect>, e: boolean, f: number, g: number, h: number, i: number, j: number): void;
}
/**
 * @hidden
 */
export declare let IAxisAnnotationManager_$type: Type;
/**
 * @hidden
 */
export declare class AxisLabelSettings extends Base implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    private aa;
    textStyle: string;
    private ax;
    textColor: Brush;
    location: AxisLabelsLocation;
    private b;
    visibility: Visibility;
    private a2;
    showFirstLabel: boolean;
    private h;
    c: AxisLabelsLocation;
    a: Axis;
    registerAxis(a: Axis): void;
    unregisterAxis(a: Axis): void;
    angle: number;
    private m;
    extent: number;
    private o;
    margin: number;
    leftMargin: number;
    private p;
    rightMargin: number;
    private q;
    topMargin: number;
    private r;
    bottomMargin: number;
    private n;
    private au;
    horizontalAlignment: HorizontalAlignment;
    private az;
    verticalAlignment: VerticalAlignment;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    ar(a: string, b: any, c: any): void;
    protected aq(a: any, b: string, c: any, d: any): void;
    j(): boolean;
    k(): boolean;
    static readonly extentPropertyDefault: number;
    readonly i: boolean;
    private f;
    g(a: DomRenderer): FontInfo;
}
/**
 * @hidden
 */
export declare class TitleSettings extends AxisLabelSettings {
    static $t: Type;
    constructor();
    private a4;
    position: AxisTitlePosition;
    protected aq(a: any, b: string, c: any, d: any): void;
}
/**
 * @hidden
 */
export declare abstract class Axis extends Control implements INotifyPropertyChanged {
    static $t: Type;
    a2(): AxisView;
    a3: AxisView;
    gx(a: AxisView): void;
    gk(): void;
    private bs;
    readonly bt: SRProvider;
    private a7;
    readonly a8: IAxisVisualDataManager;
    dx(): number;
    fb(): any;
    fa(): any;
    protected get_b4(): boolean;
    readonly b4: boolean;
    protected get_cc(): boolean;
    readonly cc: boolean;
    protected get_b2(): boolean;
    readonly b2: boolean;
    protected get_ce(): boolean;
    readonly ce: boolean;
    protected get_ch(): boolean;
    readonly ch: boolean;
    protected get_cf(): boolean;
    readonly cf: boolean;
    protected get_b7(): boolean;
    readonly b7: boolean;
    protected get_cd(): boolean;
    readonly cd: boolean;
    protected get_b5(): boolean;
    readonly b5: boolean;
    protected get_b6(): boolean;
    readonly b6: boolean;
    ai(): Axis;
    constructor();
    private a5;
    readonly a6: IAxisAnnotationManager;
    readonly b3: boolean;
    private gi;
    private gj;
    private gg;
    private gh;
    provideRenderer(a: DomRenderer): void;
    as: (item: any) => string;
    gu(a: Rect, b: Rect): void;
    abstract at(): AxisLabelPanelBase;
    ac(): void;
    ho: Canvas;
    bn: IFastItemsSourceProvider;
    private bm;
    bh: SeriesViewer;
    private bg;
    be: XamDataChart;
    readonly br: (sender: any, e: RectChangedEventArgs) => void;
    private bw;
    cr: boolean;
    private c5;
    ef: number;
    private c0;
    dg: number;
    private db;
    el: number;
    private c8;
    ei: number;
    private aq;
    ar: AxisExtentType;
    private c4;
    ee: number;
    df: number;
    private da;
    ek: number;
    private c7;
    eh: number;
    private bj;
    private bi;
    bl: FontInfo;
    private fc;
    f3: string;
    private c6;
    eg: number;
    dh: number;
    private dc;
    em: number;
    private c9;
    ej: number;
    private ex;
    e2: number;
    private ew;
    e1: number;
    private ev;
    e0: number;
    ey: number;
    private je;
    jh: VerticalAlignment;
    private de;
    eo: number;
    private dd;
    en: number;
    hg(): void;
    private g8;
    private g9;
    hp: TextBlock;
    gc: string;
    iu: Brush;
    iq: Brush;
    ep: number;
    iy: DoubleCollection;
    it: Brush;
    ir: Brush;
    io: Brush;
    d5: number;
    iw: DoubleCollection;
    is: Brush;
    ip: Brush;
    d8: number;
    ix: DoubleCollection;
    iv: Brush;
    er: number;
    iz: DoubleCollection;
    eq: number;
    di: number;
    private hi;
    b8: boolean;
    ca: boolean;
    cb: boolean;
    cq: boolean;
    static readonly ik: DependencyProperty;
    ez: number;
    ax: AxisLabelSettings;
    dm(): number;
    il(): HorizontalAlignment;
    jf(): VerticalAlignment;
    im(): HorizontalAlignment;
    jg(): VerticalAlignment;
    dp(): number;
    dr(): number;
    dq(): number;
    dn(): number;
    du(): number;
    dw(): number;
    dv(): number;
    dt(): number;
    ay(): AxisLabelsLocation;
    az(): AxisLabelsLocation;
    ah: Axis;
    e4: any;
    rangeChanged: (sender: any, e: AxisRangeChangedEventArgs) => void;
    protected g6(a: AxisRangeChangedEventArgs): void;
    bd: TitleSettings;
    ds(): number;
    dl(): number;
    readonly al: AxisAnnotationCollection;
    private aj;
    readonly am: AxisAnnotationCollection;
    private ak;
    private i1;
    i8: Rect;
    i7: Rect;
    hj(): void;
    ct(a: Rect, b: Rect, c: AxisView): boolean;
    cg(): boolean;
    cx: List$1<any>;
    cy: List$1<LabelPosition>;
    au: AxisLabelPanelBase;
    protected hm(a: Rect, b: Rect): void;
    private bv;
    ci: boolean;
    protected i5(): Rect;
    protected hn(a: Rect, b: Rect): void;
    g7(): void;
    a4: ContentInfo;
    eu: DomRenderer;
    bf: BindingFormatter;
    protected gz(a: any, b: string, c: any, d: any): void;
    private _coercionMethods;
    coercionMethods: any;
    private bu;
    protected get_expectFunctions(): boolean;
    protected set_expectFunctions(a: boolean): void;
    expectFunctions: boolean;
    cl: boolean;
    private he;
    cs: boolean;
    protected gw(a: GeometryCollection, b: number, c: number, d: Rect): void;
    protected gv(a: GeometryCollection, b: number, c: Rect, d: PathRenderingInfo, e: boolean): void;
    protected hl(a: GeometryCollection, b: number, c: number, d: Rect): void;
    protected hk(a: GeometryCollection, b: number, c: Rect, d: PathRenderingInfo, e: boolean): void;
    private b9;
    protected hf(a: number, b: number, c: Rect, d: Rect, e: Rect, f: number, g: number): {
        p0: number;
        p1: number;
    };
    dj(a: number, b: number, c: number, d: PathRenderingInfo): number;
    gn(a: GeometryCollection): void;
    protected gm(): void;
    ha(): void;
    hb(a: boolean): void;
    renderRequested: (sender: any, e: RenderRequestedEventArgs) => void;
    ba: LabelFontHeuristics;
    static d7: number;
    ec(): number;
    ea(): number;
    eb(): number;
    protected readonly cm: boolean;
    gp(a: boolean): void;
    private c2;
    private by;
    hd(): void;
    private c3;
    a9(): LabelFontHeuristics;
    bk(): FontInfo;
    private gq;
    cj: boolean;
    cn(): boolean;
    co(a: boolean): boolean;
    cp(): boolean;
    protected hc(a: boolean): void;
    hh(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected g5(a: string, b: any, c: any): void;
    cz: List$1<Series>;
    ck(a: Series): boolean;
    bx(a: Series): boolean;
    e9: any;
    fo: string;
    ag: any[];
    e6(a: any, b: string): any;
    private cv;
    protected f0(a: string): string;
    private cu;
    protected e7(a: any, b: string, c: string): any;
    e8(a: any): any;
    fl(a: number): string;
    d9(): number;
    dy(a: number, b: ScalerParams): number;
    dz(a: number, b: ScalerParams, c: CategoryMode): number;
    i4(a: Rect): Rect;
    i3(): Rect;
    i2(): Rect;
    protected i6(a: Rect, b: Rect): Rect;
    d0(a: number, b: Rect, c: Rect): number;
    gs(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    gr(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    d1(a: number, b: ScalerParams): number;
    d2(a: number, b: ScalerParams, c: CategoryMode): number;
    d3(a: number, b: Rect, c: Rect): number;
    gt(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    ed(a: number): number;
    abstract readonly a0: AxisOrientation;
    jd: Size;
    gy(): void;
    an: AxisComponentsForView;
    ao(): AxisComponentsForView;
    dk: number;
    private c1;
    d6: number;
    b1(): boolean;
    d4(): number;
    protected gl(): void;
    go(a: AxisRangeChangedEventArgs): void;
    bq: Pool$1<TextBlock>;
    bp: Pool$1<TextBlock>;
    bo: Pool$1<Rectangle>;
    readonly i9: Path;
    readonly ja: Path;
    readonly jc: Path;
    readonly jb: Path;
    bc(): SyncSettings;
    ap(): AxisComponentsFromView;
    private av;
    readonly aw: AxisLabelSettings;
    g0(a: RenderingContext, b: RenderingContext): void;
    b0(): boolean;
    e5(): any;
    private _cw;
    cw(): IEnumerable$1<Series>;
    g1(a: string): void;
    g4(a: any): void;
    g3(a: any): void;
    et: CultureInfo;
    i0(a: number, b: Rect, c: Rect, d?: any, e?: any): Geometry;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AxisCollection extends ObservableCollection$1<Axis> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class AxisLabelManager extends Base {
    static $t: Type;
    e: List$1<any>;
    f: List$1<LabelPosition>;
    b: AxisLabelPanelBase;
    a: Axis;
    c: (arg1: number) => void;
    constructor();
    m(a: Rect, b: Rect): void;
    i(a: any, b: LabelPosition): void;
    s(): void;
    static j(a: FrameworkElement): void;
    private static k;
    static l(a: FrameworkElement): void;
    h(a: FrameworkElement): void;
    q(a: number): void;
    n(a: number): void;
    t(a: number): FrameworkElement;
    r(a: number): void;
    readonly d: boolean;
    p(): void;
    o(): void;
    g(): void;
}
/**
 * @hidden
 */
export declare abstract class AxisLabelPanelBase extends Panel {
    static $t: Type;
    ad(): AxisLabelPanelBaseView;
    b8(a: AxisLabelPanelBaseView): void;
    ae: AxisLabelPanelBaseView;
    cl: Rect;
    bz(): void;
    ce(): void;
    cd(): void;
    constructor();
    bn: number;
    ac: Axis;
    private aj;
    at: boolean;
    private ax;
    a1: List$1<any>;
    a2: List$1<LabelPosition>;
    co: Rect;
    private ck;
    cp: Rect;
    private cj;
    cn: Rect;
    private a4;
    a8: number;
    bo: () => boolean;
    a3: List$1<FrameworkElement>;
    a0: List$1<Rect>;
    af: AxisLabelSettings;
    am: boolean;
    ap: boolean;
    aq: boolean;
    ar: boolean;
    bq: any;
    ak: boolean;
    protected al(a: List$1<Rect>, b: List$1<boolean>): boolean;
    protected bp(a: number, b: List$1<Rect>, c: List$1<boolean>): {
        ret: number;
        p1?: List$1<Rect>;
    };
    ay(): List$1<Rect>;
    bx(): void;
    bt(a: Size): void;
    bd(): number;
    bh(): number;
    ao(a: number, b: Rect): boolean;
    bc(a: any): number;
    bm(a: any): number;
    be(a: any): number;
    bb(a: any): number;
    an(): boolean;
    protected ch(a: Rect, b: Rect): void;
    protected b4(a: Rect, b: Rect): void;
    az(): List$1<Rect>;
    bg(a: number, b: Size): number;
    bf(a: number, b: Size): number;
    bk(): number;
    bi(): number;
    bj(): number;
    bl(): number;
    cq(a: Size): Size;
    cm(): Rect;
    protected bw(a: Size): void;
    protected bv(a: Size): void;
    protected b0(): void;
    protected aw(): IEnumerable$1<number>;
    readonly ag: AxisLabelsLocation;
    cg(a: GeometryCollection, b: number, c: number, d: number, e: Rect, f: PathRenderingInfo): void;
    b3(a: GeometryCollection, b: number, c: number, d: number, e: Rect, f: PathRenderingInfo): void;
    cb(a: FrameworkElement, b: number): void;
    cc(a: FrameworkElement): void;
    b2(a: FrameworkElement, b: number): void;
    cr(a: Size): Size;
    static readonly ci: DependencyProperty;
    a9: number;
    a5: number;
    ai(a: TitleSettings): AxisTitlePosition;
    ah(): AxisLabelsLocation;
    as(a: AxisLabelsLocation): boolean;
    private _au;
    au(): IEnumerable$1<any>;
    bs(a: number, b: TextBlock, c: number, d: number, e: number): string;
    by(a: any): void;
    b7(a: FrameworkElement): void;
    private _av;
    av(): IEnumerable$1<any>;
    protected a6: number;
    protected a7: number;
    b1(): void;
    cf(): void;
    b5(): void;
    ba(a: Rect): number;
    b6(): void;
    b9(a: RenderingContext): void;
    bu(): void;
    ca(): void;
}
/**
 * @hidden
 */
export declare abstract class CategoryAxisBase extends Axis implements ICategoryScaler {
    static $t: Type;
    a2(): AxisView;
    protected get_b6(): boolean;
    gx(a: AxisView): void;
    ji: CategoryAxisBaseView;
    constructor();
    ct(a: Rect, b: Rect, c: AxisView): boolean;
    kq(): void;
    kp(): void;
    jt: List$1<number>;
    protected get_b4(): boolean;
    k1(a: Point, b: boolean, c: number): Rect;
    k2(a: Point, b: boolean, c: number, d: boolean): Rect;
    jm: IFastItemsSource;
    private jl;
    itemsSource: IEnumerable;
    static readonly ky: DependencyProperty;
    private j4;
    j5: number;
    j6: number;
    categoryMode: CategoryMode;
    private jj;
    jv: number;
    j2: number;
    jq: boolean;
    j8: number;
    private j7;
    d1(a: number, b: ScalerParams): number;
    getUnscaledValue3(a: number, b: Rect, c: Rect, d: CategoryMode): number;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    jy(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    j3(a: number): number;
    private _js;
    private js;
    private jo;
    jp(a: SeriesViewer): boolean;
    private _jr;
    private jr;
    private jn;
    ku(a: boolean): void;
    protected gz(a: any, b: string, c: any, d: any): void;
    protected ki(): void;
    kk(a: any, b: FastItemsSourceEventArgs): void;
    protected kr(a: FastItemsSourceEventArgs): void;
    private kv;
    ck(a: Series): boolean;
    bx(a: Series): boolean;
    private ks;
    kh(): void;
    kt(): void;
    kj(a: NotifyCollectionChangedEventArgs): void;
    ko(a: number, b: any, c: any): void;
    kl(): void;
    km(a: number, b: any): void;
    kn(a: number, b: any): void;
    jz(a: Rect, b: Rect, c: Rect, d: number): number;
    j0(a: Rect, b: Rect, c: Rect, d: number, e: number): number;
    getSeriesOffset(a: Rect, b: Rect, c: Rect, d: number, e: number): number;
    readonly isVertical: boolean;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    readonly j$a: boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class HorizontalAxisLabelPanelBase extends AxisLabelPanelBase {
    static $t: Type;
    ad(): AxisLabelPanelBaseView;
    b8(a: AxisLabelPanelBaseView): void;
    cs: HorizontalAxisLabelPanelBaseView;
    c4: number;
    c1: number;
    c3: number;
    c2: number;
    bx(): void;
    cu(): boolean;
    cv(): boolean;
    an(): boolean;
    ay(): List$1<Rect>;
    c6(a: List$1<Rect>, b: List$1<boolean>, c: number): void;
    private c5;
    private c7;
    protected c8(a: List$1<Rect>, b: List$1<boolean>): void;
    protected c9(): void;
    cb(a: FrameworkElement, b: number): void;
    protected cw(): boolean;
    protected ct(): boolean;
    protected bp(a: number, b: List$1<Rect>, c: List$1<boolean>): {
        ret: number;
        p1?: List$1<Rect>;
    };
    cm(): Rect;
    c0(): number;
    cx(): number;
    cz(): number;
    cy(): number;
    protected b0(): void;
}
/**
 * @hidden
 */
export declare class HorizontalAxisLabelPanel extends HorizontalAxisLabelPanelBase {
    static $t: Type;
    ah(): AxisLabelsLocation;
    as(a: AxisLabelsLocation): boolean;
}
/**
 * @hidden
 */
export declare abstract class NumericAxisBase extends Axis {
    static $t: Type;
    a2(): AxisView;
    gx(a: AxisView): void;
    jj: NumericAxisBaseView;
    protected get_cc(): boolean;
    constructor();
    kj: number;
    kb: number;
    private j5;
    kh: number;
    fb(): any;
    ke: number;
    private j8;
    ki: number;
    ka: number;
    private j4;
    fa(): any;
    kg: number;
    private j7;
    kd: number;
    kf: number;
    private j3;
    j9: number;
    d9(): number;
    kk: number;
    private j6;
    kc: number;
    kl: number;
    j0: boolean;
    private ju;
    jw: boolean;
    readonly j1: boolean;
    kn: number;
    ko: number;
    jm: NumericAxisRenderer;
    protected j2: boolean;
    protected hc(a: boolean): void;
    g4(a: any): void;
    g3(a: any): void;
    protected gz(a: any, b: string, c: any, d: any): void;
    protected k8(): void;
    ji(): AxisRange;
    k6(a: NumericAxisBase, b: number, c: number, d: boolean, e: number, f: number, g: number): {
        p5: number;
        p6: number;
    };
    cp(): boolean;
    k9(a: AxisRangeChangedEventArgs): void;
    ck(a: Series): boolean;
    bx(a: Series): boolean;
    jl(a: AxisLabelManager): NumericAxisRenderer;
    jk(): NumericAxisRenderer;
    jo(): NumericAxisRenderingParameters;
    k7(): void;
    jp(): NumericScaler;
    jn(a: Rect, b: Rect, c: Rect, d: Rect): NumericAxisRenderingParameters;
    km(a: number): number;
    jx(): boolean;
    readonly jz: boolean;
    readonly jy: boolean;
    private la;
    static readonly li: DependencyProperty;
    js: TickmarkValues;
    private jq;
    jr: TickmarkValues;
    private jt;
    jv: boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class NumericScaler extends DependencyObject {
    static $t: Type;
    static readonly ac: Rect;
    abstract t(a: NumericAxisBase, b: number, c: number, d: number, e: number): {
        p3: number;
        p4: number;
    };
    l: number;
    k: number;
    protected o: number;
    protected n: number;
    y(a: number): void;
    x(a: number): void;
    protected w(a: string, b: any, c: any): void;
    private z;
    protected m: number;
    abstract q(a: number, b: ScalerParams): number;
    abstract p(a: number, b: ScalerParams): number;
    j(a: IList$1<number>, b: number, c: number, d: ScalerParams): IList$1<number>;
    v(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    u(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AxisRendererBase extends Base {
    static $t: Type;
    constructor(a: AxisLabelManager);
    u: () => void;
    o: (viewportRect: Rect, windowRect: Rect) => boolean;
    v: () => void;
    m: (p: AxisRenderingParametersBase, value: number) => number;
    l: (p: AxisRenderingParametersBase, geometry: GeometryCollection, startValue: number, endValue: number) => void;
    k: (p: AxisRenderingParametersBase, geometry: GeometryCollection, value: number) => void;
    q: (p: AxisRenderingParametersBase, value: number) => boolean;
    n: (p: AxisRenderingParametersBase, value: number) => boolean;
    j: (p: AxisRenderingParametersBase) => void;
    e: (p: AxisRenderingParametersBase) => void;
    p: (p: AxisRenderingParametersBase, position: number, isLastLabel: boolean) => boolean;
    h: (p: AxisRenderingParametersBase, value: number) => LabelPosition;
    t: (p: AxisRenderingParametersBase, value: number) => number;
    b: AxisLabelManager;
    g: (item: any) => any;
    d: (viewportRect: Rect, windowRect: Rect, effectiveViewportRect: Rect, contentViewport: Rect) => AxisRenderingParametersBase;
    r: (p: AxisRenderingParametersBase, value: number, absoluteIndex: number, interval: number) => number;
    a: (p: AxisRenderingParametersBase, value: number, absolueIndex: number, interval: number) => number;
    f: (index: number, window: Rect, viewport: Rect, effectiveViewport: Rect) => number;
    i: (index: number) => number;
    c(a: boolean, b: Rect, c: Rect, d: Rect, e: Rect): AxisRenderingParametersBase;
    private aa;
    private ab;
    protected x(a: Rect, b: Rect): void;
    private z;
    private s;
    private y;
    w(a: AxisRenderingParametersBase, b: number, c: number, d: number): any;
}
/**
 * @hidden
 */
export declare class NumericAxisRenderer extends AxisRendererBase {
    static $t: Type;
    constructor(a: AxisLabelManager);
    w(a: AxisRenderingParametersBase, b: number, c: number, d: number): any;
    private ac;
    private ad;
    private ae;
}
/**
 * @hidden
 */
export declare class VerticalAxisLabelPanel extends AxisLabelPanelBase {
    static $t: Type;
    ad(): AxisLabelPanelBaseView;
    b8(a: AxisLabelPanelBaseView): void;
    cs: VerticalAxisLabelPanelView;
    c1: number;
    cy: number;
    c0: number;
    cz: number;
    bx(): void;
    bh(): number;
    cu(): number;
    cw(): number;
    cx(): number;
    cv(): number;
    ay(): List$1<Rect>;
    private c2;
    private c3;
    cb(a: FrameworkElement, b: number): void;
    protected ct(): boolean;
    cm(): Rect;
    ai(a: TitleSettings): AxisTitlePosition;
    ah(): AxisLabelsLocation;
    as(a: AxisLabelsLocation): boolean;
    protected b0(): void;
}
/**
 * @hidden
 */
export interface IHasCategoryAxis {
    readonly categoryAxis: CategoryAxisBase;
    getOffsetValue(): number;
    getCategoryWidth(): number;
}
/**
 * @hidden
 */
export declare let IHasCategoryAxis_$type: Type;
/**
 * @hidden
 */
export interface IHasCategoryModePreference extends IHasCategoryAxis {
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
}
/**
 * @hidden
 */
export declare let IHasCategoryModePreference_$type: Type;
/**
 * @hidden
 */
export interface IHighlightingManager {
    startHighlight(a: HighlightingInfo): void;
    endHighlight(a: HighlightingInfo): void;
    clear(): void;
    getHighlightingInfo(a: Series, b: IFastItemsSource, c: Axis, d: number, e: number, f: boolean): HighlightingInfo;
    tick(a: number): boolean;
    inProgress: boolean;
    maxHighlightingProgress: number;
    sumHighlightingProgress: number;
    maxMarkerHighlightingProgress: number;
    sumMarkerHighlightingProgress: number;
    readonly dirtySeries: List$1<Series>;
}
/**
 * @hidden
 */
export declare let IHighlightingManager_$type: Type;
/**
 * @hidden
 */
export declare class HighlightingInfo extends Base {
    static $t: Type;
    constructor();
    f: number;
    e: number;
    a: HighlightingState;
    d: number;
    c: boolean;
    b: Series;
}
/**
 * @hidden
 */
export interface ISeriesInteractionManager {
    a$i(a: Series, b: Point, c: number, d: Axis, e: ScalerParams, f: number, g: number, h: (arg1: Point) => number): number;
    a$l(a: Series, b: IList$1<number>, c: Point, d: Axis, e: ScalerParams, f: number, g: (arg1: Point) => number, h: boolean, i: boolean): number;
    a$k(a: Series, b: number, c: IList$1<number>, d: number, e: number, f: number, g: number, h: number, i: boolean): number;
    a$n(a: Series, b: Point, c: boolean, d: Axis, e: (arg1: Point) => number, f: IList$1<number>): number;
    a$d(a: Series, b: Point, c: boolean): boolean;
    a$a(a: Series, b: CategoryAxisBase, c: List$1<number[]>, d: number, e: number, f: Point, g: boolean): number[][];
    a$e(a: Series, b: Point, c: boolean, d: PathGeometry): boolean;
    a$f(a: Series, b: Point, c: PathGeometry): boolean;
    a$m(a: Series, b: Point, c: boolean, d: Axis, e: (arg1: Point) => number, f: IList$1<number>): number;
    a$j(a: Series, b: Point, c: Axis): number;
    a$g(a: Series, b: Point, c: boolean): boolean;
    a$aj(a: Series, b: Point, c: boolean, d: boolean, e: number, f: Axis, g: Axis, h: (arg1: Point, arg2: boolean, arg3: boolean) => number, i: (arg1: Point, arg2: boolean) => number, j: (arg1: Point, arg2: boolean) => number): Point;
    a$t(a: Series, b: any, c: Point, d: boolean, e: boolean): void;
    a$ai(a: Series, b: HighlightingInfo, c: Brush): Brush;
    a$w(a: Series, b: Point, c: any, d: any): void;
    a$ag(a: Series, b: Point): void;
    a$z(a: Series, b: Point, c: any, d: any): void;
    a$x(a: Series, b: Point, c: any, d: any): void;
    a$u(a: Series, b: Point, c: any, d: any): void;
    a$y(a: Series, b: Point, c: any, d: any): void;
    a$v(a: Series, b: Point, c: any, d: any): void;
    a$aa(a: Series, b: Point, c: any, d: any): void;
    a$ab(a: Series, b: Point, c: any, d: any): void;
    a$p(a: Series): string;
    a$q(a: Series): string;
    readonly a$b: boolean;
    readonly a$o: any;
    a$ah(a: Series, b: any): void;
    a$af(a: Series, b: Point, c: (arg1: any) => void): void;
    a$s(a: Series): void;
    a$ae(a: Series): void;
    readonly a$c: boolean;
    readonly a$h: Dictionary$2<string, SeriesView>;
    a$r(a: Series, b: Rect, c: Rect, d: string, e: number): void;
    a$ac(a: Series, b: SeriesViewer): void;
    a$ad(a: Series, b: string, c: SeriesViewer): void;
}
/**
 * @hidden
 */
export declare let ISeriesInteractionManager_$type: Type;
/**
 * @hidden
 */
export interface ISeriesViewerInteractionManager {
    f$a(a: SeriesViewer): ChartHitTestMode;
    f$ae(a: SeriesViewer): void;
    f$p(a: SeriesViewer, b: Point): void;
    f$ac(a: SeriesViewer, b: Point): void;
    f$q(a: SeriesViewer, b: Point, c: boolean): void;
    f$o(a: SeriesViewer, b: Point): void;
    f$aj(a: SeriesViewer): void;
    f$ab(a: SeriesViewer, b: Point): void;
    f$ak(a: SeriesViewer, b: Point, c: number, d: number, e: number): void;
    f$aa(a: SeriesViewer, b: number): void;
    f$ag(a: SeriesViewer, b: Point, c: number, d: number, e: number): void;
    f$x(a: SeriesViewer, b: Point): void;
    f$z(a: SeriesViewer, b: number): void;
    f$r(a: SeriesViewer, b: Point): void;
    f$af(a: SeriesViewer, b: Point, c: number, d: number, e: number): void;
    f$m(a: SeriesViewer, b: Point, c: boolean): void;
    f$ai(a: SeriesViewer): void;
    f$ah(a: SeriesViewer): void;
    f$am(a: SeriesViewer): void;
    f$j(a: SeriesViewer): void;
    f$g(a: SeriesViewer): void;
    f$l(a: SeriesViewer, b: Point, c: boolean): void;
    f$k(a: SeriesViewer, b: Point, c: boolean): void;
    f$al(a: SeriesViewer): void;
    f$ad(a: SeriesViewer): void;
    f$d(a: SeriesViewer, b: Key): boolean;
    f$e(a: SeriesViewer, b: Point, c: number): boolean;
    f$n(a: SeriesViewer, b: Point): void;
    f$i(a: SeriesViewer): void;
    f$h(a: SeriesViewer): void;
    readonly f$b: IHighlightingManager;
    f$c(a: SeriesViewer, b: SeriesCollection, c: RenderingContext, d: Point, e: boolean, f: DataContext, g: boolean): {
        ret: Series;
        p5: DataContext;
    };
    f$f(a: SeriesViewer, b: Point): boolean;
    f$v(a: SeriesViewer, b: SeriesCollection, c: RenderingContext, d: Point, e: boolean, f: boolean): void;
    f$u(a: SeriesViewer, b: Point): void;
    f$t(a: SeriesViewer, b: EventProxy, c: Point): void;
    f$w(a: SeriesViewer, b: EventProxy, c: Point): void;
    f$s(a: SeriesViewer, b: Point, c: boolean): void;
    f$y(a: SeriesViewer, b: boolean): void;
}
/**
 * @hidden
 */
export declare let ISeriesViewerInteractionManager_$type: Type;
/**
 * @hidden
 */
export interface IDataChartVisualDataManager {
    exportVisualData(a: XamDataChart): any;
}
/**
 * @hidden
 */
export declare let IDataChartVisualDataManager_$type: Type;
/**
 * @hidden
 */
export interface IAxisVisualDataManager {
    exportVisualData(a: Axis): any;
}
/**
 * @hidden
 */
export declare let IAxisVisualDataManager_$type: Type;
/**
 * @hidden
 */
export interface ISeriesVisualDataManager {
    exportVisualData(a: Series, b: Rect): any;
    exportMarkerVisualData(a: MarkerSeries, b: any): void;
    getMarkerVisualData(a: Series, b: Marker, c: DataTemplate): any;
    copyVisualData(a: any, b: any): void;
    exportTrendlineData(a: Series, b: any, c: Polyline): void;
    exportStackedVisualData(a: Series, b: Rect): any;
    createFragmentVisualData(a: Series, b: Rect, c: string, d: string): any;
    addSubSeriesVisualData(a: any, b: any): void;
    exportRectangleData(a: any, b: Rectangle, c: string, d: string[]): void;
    exportMarkerVisualDataFromMarker(a: Series, b: any, c: ContentControl): void;
    exportPathData(a: any, b: Path, c: string, d: string[]): void;
    exportPolylineData(a: any, b: Polyline, c: string, d: string[]): void;
    exportPolygonData(a: any, b: Polygon, c: string, d: string[]): void;
    exportSeriesPixelsData(a: any, b: number[], c: number, d: number): void;
    addPointerTooltipData(a: any, b: any, c: number, d: number, e: List$1<string>): void;
    exportPointerTooltipData(a: Polygon, b: Polyline, c: Rectangle, d: Rect): any;
    exportCalloutData(a: number, b: number, c: number, d: number, e: any, f: Rectangle, g: TextBlock, h: FontInfo, i: Line, j: string, k: string[]): void;
}
/**
 * @hidden
 */
export declare let ISeriesVisualDataManager_$type: Type;
/**
 * @hidden
 */
export declare class XamDataChart extends SeriesViewer {
    static $t: Type;
    static n8: number;
    static n7: number;
    private _xsr;
    private readonly XSRP;
    private nj;
    readonly nk: IDataChartVisualDataManager;
    static staticInit(): void;
    static of(a: Series): number;
    constructor();
    protected je(a: any, b: string, c: any, d: any): void;
    private o4;
    nu: boolean;
    eg(): number;
    eh(): number;
    protected ka(): void;
    od: number;
    oe: number;
    private nz;
    n5: number;
    private n0;
    n6: number;
    c3(): boolean;
    c4(): boolean;
    ns: boolean;
    nx: boolean;
    nt: boolean;
    nv: boolean;
    ni: GridMode;
    np: boolean;
    nw: boolean;
    nb: BrushCollection;
    nc: BrushCollection;
    ne: BrushCollection;
    nd: BrushCollection;
    pq: Brush;
    po: Brush;
    pp: Brush;
    readonly axes: AxisCollection;
    private nf;
    private o1;
    private o2;
    axisRangeChanged: (sender: any, e: ChartAxisRangeChangedEventArgs) => void;
    private o3;
    private static o5;
    kj(a: SyncLink, b: SyncLink): void;
    private nm;
    getFontInfo(): FontInfo;
    o6(): void;
    getFontBrush(): Brush;
    protected hj(): void;
    l6(): Brush;
    dd(): boolean;
    protected ke(): void;
    l7(a: number): Brush;
    private pr;
    mb(a: number): Brush;
    mc(a: number): Brush;
    md(a: number): Brush;
    cl(): boolean;
    private nr;
    protected bm(): SeriesViewerView;
    protected i2(a: SeriesViewerView): void;
    nl: XamDataChartView;
    ju(): void;
    private n2;
    oa: number;
    private n4;
    oc: number;
    private n3;
    ob: number;
    private n1;
    n9: number;
    protected mt(a: Rect): Rect;
    mz(): Rect;
    og(): any;
    oo(): string;
    jb(): void;
    jw(): void;
    ny(a: Axis): List$1<Axis>;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class LabelPanelArranger extends Base {
    static $t: Type;
    static e(a: List$1<AxisLabelPanelBase>, b: Rect): Rect;
    private static a;
    static b(a: AxisLabelPanelBase): AxisLabelsLocation;
    private static c;
    static d(a: List$1<AxisLabelPanelBase>, b: LabelPanelsArrangeState, c: Rect, d: (arg1: AxisLabelPanelBase, arg2: Rect) => void): void;
}
/**
 * @hidden
 */
export declare class ChartContentManager extends DependencyObject {
    static $t: Type;
    private l;
    private q;
    private s;
    private t;
    constructor(a: SeriesViewer);
    k(a: ChartContentType, b: DependencyObject, c: (arg1: boolean) => void): ContentInfo;
    ac(a: ChartContentType, b: DependencyObject): void;
    private m;
    private u;
    z(a: DomRenderer): void;
    y(): void;
    ab(a: ChartContentType, b: DependencyObject, c: ContentInfo, d: boolean): void;
    private p;
    private j;
    x(): void;
    private v;
    private _r;
    private r;
    w(a: Size): void;
    n: boolean;
    o: boolean;
    ad(a: ChartContentType, b: DependencyObject, c: ContentInfo, d: Rect): void;
    aa(a: Axis, b: ContentInfo): void;
}
/**
 * @hidden
 */
export declare class ContentInfo extends Base {
    static $t: Type;
    h: DependencyObject;
    a: (arg1: boolean) => void;
    b: boolean;
    c: boolean;
    i: Rect;
    readonly d: boolean;
    g(): void;
    f(): void;
    e: boolean;
}
/**
 * @hidden
 */
export declare abstract class Series extends Control implements INotifyPropertyChanged, IProvidesViewport, ILegendSeries, ILegendOwner, ILegendTemplateProvider {
    static $t: Type;
    bi: SeriesView;
    private static e5;
    fk: number;
    lq: Rect;
    private e3;
    e4: DomRenderer;
    provideRenderer(a: DomRenderer): void;
    gw(): string;
    constructor();
    private static readonly k3;
    protected hp(a: any, b: PropertyChangedEventArgs): void;
    private b1;
    readonly b2: SRProvider;
    private a1;
    readonly a2: ISeriesVisualDataManager;
    protected readonly dz: Dictionary$2<string, SeriesView>;
    private az;
    readonly a0: ISeriesInteractionManager;
    readonly cx: boolean;
    bt: DoubleAnimator;
    iv(a: SeriesView): void;
    it(): void;
    iu(): void;
    bg(): SeriesView;
    protected bf(): SeriesView;
    jy: Canvas;
    dt(): boolean;
    fs(a: any, b: string): any;
    private dy;
    protected gv(a: string): string;
    private dx;
    protected ft(a: any, b: string, c: string): any;
    eb(a: Point): number;
    fa(a: Point): number;
    protected get_c1(): boolean;
    readonly c1: boolean;
    ap(): CategoryAxisBase;
    e8(a: Point): number;
    fp(a: Point): any;
    protected fu(a: Series, b: Point): any;
    e7(): number;
    fb(): number;
    fg(): number;
    readonly container: ILegendOwner;
    readonly hasSubItems: boolean;
    protected ci(): boolean;
    forSubItems(a: (arg1: any) => void): void;
    protected h7(a: (arg1: any) => void): void;
    h8(a: (arg1: Series) => boolean): void;
    la(): Brush;
    resolveLegendIndex(): number;
    a6(): Series;
    protected get_cj(): boolean;
    readonly cj: boolean;
    protected get_isVertical(): boolean;
    readonly isVertical: boolean;
    protected get_cs(): boolean;
    readonly cs: boolean;
    protected get_ck(): boolean;
    readonly ck: boolean;
    protected get_c0(): boolean;
    readonly c0: boolean;
    protected get_c4(): boolean;
    readonly c4: boolean;
    protected get_c2(): boolean;
    readonly c2: boolean;
    protected get_isStacked(): boolean;
    readonly isStacked: boolean;
    protected get_cr(): boolean;
    readonly cr: boolean;
    protected get_c3(): boolean;
    readonly c3: boolean;
    protected get_cl(): boolean;
    readonly cl: boolean;
    protected get_ct(): boolean;
    readonly ct: boolean;
    protected get_c5(): boolean;
    readonly c5: boolean;
    protected get_c6(): boolean;
    readonly c6: boolean;
    a5(): Series;
    protected get_cm(): boolean;
    readonly cm: boolean;
    protected get_cn(): boolean;
    readonly cn: boolean;
    d9(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    protected ea(a: Point, b: number, c: Axis, d: ScalerParams, e: number, f: number, g: (arg1: Point) => number): number;
    protected get_dv(): boolean;
    readonly dv: boolean;
    protected ep(a: IList$1<number>, b: Point, c: Axis, d: ScalerParams, e: number, f: (arg1: Point) => number, g: boolean, h: boolean): number;
    ef(a: number, b: IList$1<number>, c: number, d: number, e: number, f: number, g: number, h: boolean): number;
    ff(a: Point, b: boolean, c: Axis, d: (arg1: Point) => number, e: IList$1<number>): number;
    ee(a: boolean): number;
    ah(a: Point): Point[][];
    ai(a: Point): Point[][];
    protected dg(a: Point, b: boolean): boolean;
    aj(a: CategoryAxisBase, b: List$1<number[]>, c: number, d: number, e: Point, f: boolean): number[][];
    protected di(a: Point, b: boolean, c: PathGeometry): boolean;
    protected dj(a: Point, b: PathGeometry): boolean;
    fd(a: Point, b: boolean, c: Axis, d: (arg1: Point) => number, e: IList$1<number>): number;
    ed(a: Point, b: Axis): number;
    fe(a: Point, b: boolean): number;
    fc(a: Point, b: boolean): number;
    en(a: Point, b: boolean, c: boolean): number;
    lm(a: Point, b: boolean, c: boolean): Point;
    lv(a: Point): Rect;
    ak(a: Point): Rect[];
    lw(a: Point): Rect;
    al(a: Point): Rect[];
    lx(a: Point): Rect;
    ly(a: Point): Rect;
    protected dk(a: Point, b: boolean): boolean;
    protected lo(a: Point, b: boolean, c: boolean, d: number, e: Axis, f: Axis, g: (arg1: Point, arg2: boolean, arg3: boolean) => number, h: (arg1: Point, arg2: boolean) => number, i: (arg1: Point, arg2: boolean) => number): Point;
    ej(a: Point, b: boolean, c: boolean): number;
    li(a: Point, b: boolean, c: boolean): Point;
    el(a: Point, b: boolean, c: boolean): number;
    lk(a: Point, b: boolean, c: boolean): Point;
    ln(a: Point, b: boolean, c: boolean): Point;
    eo(a: Point, b: boolean, c: boolean): number;
    lj(a: Point, b: boolean, c: boolean): Point;
    ek(a: Point, b: boolean, c: boolean): number;
    ll(a: Point, b: boolean, c: boolean): Point;
    em(a: Point, b: boolean, c: boolean): number;
    e9(a: Point): number;
    eg(): number;
    ec(a: Point): number;
    fq(a: Point): any;
    ch(a: List$1<SeriesPointOfInterest>, b: boolean, c: number): boolean;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected raisePropertyChanged(a: string, b: any, c: any): void;
    protected get_hasMarkers(): boolean;
    readonly hasMarkers: boolean;
    ib(): void;
    k7(): Brush;
    k8(): Brush;
    j0(): DataTemplate;
    lp(a: Point): Point;
    lh(a: Point): Point;
    fv(a: any, b: Point): any;
    c9(a: any): boolean;
    an(a: Axis): AxisRange;
    ao(): AxisRange;
    je(a: boolean): void;
    renderRequested: (sender: any, e: RenderRequestedEventArgs) => void;
    private h2;
    jf(a: boolean): void;
    protected dm: boolean;
    protected ht(): void;
    protected hx(): void;
    bh: SeriesView;
    jg(a: Rect, b: RenderSurface): void;
    jd(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    getEffectiveViewport1(a: SeriesView): Rect;
    lr(a: SeriesView): Rect;
    lu(a: Rect): Rect;
    lt(a: SeriesView): Rect;
    getEffectiveViewport(): Rect;
    i8(): void;
    private i9;
    ja(a: string): void;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    dw(a: Rect, b: Rect, c: SeriesView): boolean;
    hw(a: boolean, b: SeriesView): void;
    protected cb(): boolean;
    cc(a: SeriesView): boolean;
    iw(a: Rect, b: Rect): void;
    protected ju(a: Rect, b: Rect): void;
    protected jt(a: Rect, b: Rect): void;
    aq: ContentInfo;
    private b6;
    dl: boolean;
    protected h6(a: Series): void;
    protected im(): void;
    il(): void;
    protected get_cw(): boolean;
    readonly cw: boolean;
    protected get_isUsableInLegend(): boolean;
    readonly isUsableInLegend: boolean;
    protected ir(): void;
    io(): void;
    protected ix(): void;
    iy(): void;
    protected de: boolean;
    protected df: boolean;
    protected c8(): boolean;
    protected iz(a: boolean): void;
    private b7;
    protected dn: boolean;
    protected readonly dp: boolean;
    protected v(): void;
    protected w(a: Visibility, b: Visibility): void;
    protected i0(a: any, b: string, c: any, d: any): void;
    h4(): void;
    protected cg(): boolean;
    protected get_cv(): boolean;
    protected readonly cv: boolean;
    cd: boolean;
    protected h1(a: Series): void;
    bn: SyncLink;
    private bm;
    bs: SeriesViewer;
    private br;
    bq: XamDataChart;
    readonly d3: (sender: any, e: NotifyCollectionChangedEventArgs) => void;
    readonly a4: (sender: any, e: PropertyUpdatedEventArgs) => void;
    readonly b0: (sender: any, e: RectChangedEventArgs) => void;
    itemsSource: IEnumerable;
    static readonly ke: DependencyProperty;
    bz: IFastItemsSource;
    e0: (sender: any, e: FastItemsSourceEventArgs) => void;
    protected hz(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    legend: IChartLegend;
    static readonly ki: DependencyProperty;
    jx: Control;
    private jw;
    fw(): any;
    protected jv(): Control;
    aw: IChartLegend;
    private av;
    l0: Visibility;
    legendItemBadgeTemplate: DataTemplate;
    static readonly kf: DependencyProperty;
    bl: StandardLegendItems;
    bj: StandardLegendBadges;
    bk: StandardLegendItems;
    legendItemTemplate: DataTemplate;
    static readonly kg: DependencyProperty;
    jz: DataTemplate;
    static readonly j8: DependencyProperty;
    fh: number;
    static readonly kb: DependencyProperty;
    js(): void;
    h3(): void;
    protected jp(): void;
    bu: (time: number) => number;
    bv: (time: number) => number;
    cf: boolean;
    fi: number;
    ez: number;
    ca(): boolean;
    jm(): void;
    eu: number;
    fx: any;
    k6: Brush;
    k4: Brush;
    k9: Brush;
    k5: Brush;
    es: number;
    ey: number;
    ld: PenLineCap;
    lc: DoubleCollection;
    toolTip: any;
    cu: boolean;
    cp: boolean;
    protected get_cq(): boolean;
    readonly cq: boolean;
    ev: number;
    lb: Color;
    du: boolean;
    ew: number;
    ex: number;
    b9: boolean;
    d7: number;
    d6: number;
    jo(): void;
    private b5;
    co: boolean;
    dd: boolean;
    as(a: any): DataContext;
    fj: number;
    bp: TransitionInSpeedType;
    protected bo(): TransitionInSpeedType;
    fn: any;
    jc(): void;
    jh(): void;
    jb(): void;
    hu(): void;
    ic(): void;
    private static _d1;
    static d1(a: (arg1: number) => number, b: number, c: number): IEnumerable$1<number>;
    static d0(a: (arg1: number) => number, b: number): IEnumerable$1<number>;
    lf: PenLineCap;
    le: PenLineCap;
    private a7;
    a8(): SeriesComponentsForView;
    ji(a: Canvas): void;
    eq(): number;
    er(): number;
    private b8;
    protected get_dq(): boolean;
    protected set_dq(a: boolean): void;
    protected dq: boolean;
    readonly db: boolean;
    c7: boolean;
    at(a: any, b: Point): HighlightingInfo;
    au(a: any, b: Point): HighlightingInfo;
    is(a: Point, b: any, c: any): void;
    jl(a: Point): void;
    private hr;
    private hv;
    hq(a: IChartLegend, b: IChartLegend): void;
    private hs;
    i7(a: IFastItemsSourceProvider): void;
    i6(a: IFastItemsSourceProvider): void;
    protected ax(): IChartLegend;
    protected dc(): boolean;
    da(a: boolean): boolean;
    protected h0(a: Axis): void;
    protected i5(a: Axis): void;
    a9(): SeriesComponentsFromView;
    jq(a: Canvas): void;
    jk(a: Point, b: (arg1: any) => void): void;
    protected get_ds(): boolean;
    readonly ds: boolean;
    i1(a: RenderingContext, b: RenderingContext): void;
    i3(a: Rect): void;
    ia(a: NotifyCollectionChangedEventArgs): void;
    ij(a: number, b: any, c: any): void;
    ig(): void;
    ih(a: number, b: any): void;
    ii(a: number, b: any): void;
    jn(): void;
    fz: any;
    e2: (arg1: any) => any;
    dh(a: Point, b: boolean): boolean;
    protected _coercionMethods: any;
    protected get_coercionMethods(): any;
    protected set_coercionMethods(a: any): void;
    coercionMethods: any;
    private b4;
    protected get_expectFunctions(): boolean;
    protected set_expectFunctions(a: boolean): void;
    expectFunctions: boolean;
    ar(a: Point, b: boolean): DataContext;
    private bb;
    be: SeriesHitTestMode;
    protected bd(): SeriesHitTestMode;
    private ba;
    bc: SeriesHitTestMode;
    protected bw(a: string): IFastItemColumn$1<number>;
    protected bx(a: string): IFastItemColumn$1<number>;
    protected by(a: string): IFastItemColumn$1<any>;
    protected readonly lz: Rect;
    protected get_cz(): boolean;
    readonly cz: boolean;
    protected get_cy(): boolean;
    readonly cy: boolean;
    jj(a: Brush, b: Brush): void;
    b3: (arg1: SeriesViewer) => void;
    protected hy(a: any, b: any): void;
    fo(): any;
    protected h5(a: any): void;
    private lg;
    id(a: Point): void;
    protected iq(a: Point): void;
    ie(): void;
    ik(): void;
    am(a: Axis): Axis;
    ag(): Axis[];
    eh(): number;
    static ei(a: IList$1<number>, b: ISortingAxis): number;
    ip(): void;
    private d4;
    d8: number;
    private d5;
    et: number;
    protected jr(): void;
    fr(a: any): any;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class MarkerSeries extends Series {
    static $t: Type;
    l1: MarkerSeriesView;
    constructor();
    iv(a: SeriesView): void;
    protected get_hasMarkers(): boolean;
    k7(): Brush;
    k8(): Brush;
    j0(): DataTemplate;
    l2: MarkerType;
    mn: DataTemplate;
    l7: number;
    ml: DataTemplate;
    mm: DataTemplate;
    private static mk;
    static readonly mo: DataTemplate;
    m1: Brush;
    static readonly ms: DependencyProperty;
    mz: Brush;
    m2: Brush;
    m0: Brush;
    m3: Style;
    l6: boolean;
    l4(): boolean;
    protected i0(a: any, b: string, c: any, d: any): void;
    static mc(a: MarkerType): string;
    static l3(a: Series, b: MarkerType): MarkerType;
    protected jp(): void;
    protected h5(a: any): void;
    protected l5(a: Point, b: boolean): boolean;
    ar(a: Point, b: boolean): DataContext;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class SyncLink extends FrameworkElement implements INotifyPropertyChanged, IFastItemsSourceProvider {
    static $t: Type;
    constructor();
    ai: string;
    protected am(a: any, b: string, c: any, d: any): void;
    releaseFastItemsSource(a: IEnumerable): IFastItemsSource;
    static ah: (arg1: IEnumerable) => IFastItemsSource;
    private static ad;
    getFastItemsSource(a: IEnumerable): IFastItemsSource;
    ae(a: IEnumerable): IFastItemsSource;
    private af;
    aq: Rect;
    private ar;
    private as;
    readonly ag: IList$1<SeriesViewer>;
    ab: ChartCollection;
    private aj;
    ak(a: SeriesViewer, b: Point): void;
    al(a: SeriesViewer, b: Rect): void;
    ao(a: SeriesViewer, b: Rect): void;
    ap(a: SeriesViewer, b: Rect, c: boolean): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected an(a: string, b: any, c: any): void;
}
/**
 * @hidden
 */
export declare class SyncLinkManager extends Base {
    static $t: Type;
    private static b;
    static instance(): SyncLinkManager;
    private d;
    readonly e: number;
    constructor();
    getLink(a: string): SyncLink;
    releaseLink(a: SyncLink): void;
}
/**
 * @hidden
 */
export declare class SyncManager extends Base {
    static $t: Type;
    static e(a: SeriesViewer): void;
    static c(a: SeriesViewer): void;
    static b(a: SeriesViewer, b: string, c: string): void;
    static d(a: DependencyObject, b: SyncSettings): void;
    static a(a: DependencyObject): SyncSettings;
}
/**
 * @hidden
 */
export declare class ChartCollection extends ObservableCollection$1<SeriesViewer> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class SeriesCollection extends ObservableCollection$1<Series> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class ChartCursorEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Series, c: any);
    toString(): string;
    private _item;
    item: any;
    private _series;
    series: Series;
    private _seriesViewer;
    seriesViewer: SeriesViewer;
    readonly chart: XamDataChart;
}
/**
 * @hidden
 */
export declare class DataChartMouseButtonEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Series, c: any, d: MouseButtonEventArgs);
    toString(): string;
    protected g: MouseButtonEventArgs;
    handled: boolean;
    getPosition(a: UIElement): Point;
    readonly originalSource: any;
    private _item;
    item: any;
    private _series;
    series: Series;
    private _chart;
    chart: SeriesViewer;
}
/**
 * @hidden
 */
export declare class ChartMouseEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Series, c: any, d: MouseEventArgs);
    toString(): string;
    private f;
    getPosition(a: UIElement): Point;
    readonly originalSource: any;
    private _item;
    item: any;
    private _series;
    series: Series;
    private _chart;
    chart: SeriesViewer;
}
/**
 * @hidden
 */
export declare class AxisComponentsForView extends Base {
    static $t: Type;
    a: AxisLabelPanelBase;
}
/**
 * @hidden
 */
export declare class AxisLabelPanelBaseView extends Base {
    static $t: Type;
    protected a: AxisLabelPanelBase;
    av: Path;
    constructor(a: AxisLabelPanelBase);
    aa(a: FrameworkElement, b: Rect, c: number, d: number, e: number, f: number): void;
    z(a: Rectangle, b: TextBlock, c: LabelPosition, d: Rect, e: number, f: number, g: number, h: number): void;
    ad(a: FrameworkElement): void;
    ag(a: any): void;
    ah(a: any, b: Size): void;
    ai(a: FrameworkElement, b: number): void;
    aq(a: Rectangle, b: TextBlock, c: LabelPosition, d: Rect, e: number, f: number, g: number, h: number, i: number): void;
    x(a: TextBlock, b: number, c: number, d: number): string;
    ae(): void;
    g(): IEnumerable$1<any>;
    l(a: any): number;
    n(a: any): number;
    am(): void;
    m(a: any): number;
    w(a: any): number;
    ac(): void;
    aj(): void;
    protected e: RenderingContext;
    f(): RenderingContext;
    ak(a: RenderingContext): void;
    y(): void;
    protected al(): void;
    private au;
    protected ao(a: TextBlock): void;
    an(): void;
    d(): FontInfo;
    as(): Brush;
    private c;
    af(): void;
    private h;
    private ar;
    private i;
    j(): number;
    k(): number;
    protected ap(): void;
    ab(a: Size): void;
    protected aw(): Thickness;
    v(): number;
    s(): number;
    t(): number;
    u(): number;
    at(): GeometryCollection;
    b(): PathRenderingInfo;
    r(): number;
    p(): number;
    q(): number;
    o(): number;
}
/**
 * @hidden
 */
export declare class AxisView extends Base implements ISchedulableRender {
    static $t: Type;
    protected a: Axis;
    constructor(a: Axis);
    ag(): void;
    ai(a: any): void;
    a7: Path;
    a8: Path;
    ba: Path;
    a9: Path;
    ax(): TextBlock;
    aq(a: TextBlock): void;
    as(a: TextBlock): void;
    ar(a: TextBlock): void;
    bc(): Rectangle;
    p(a: Rectangle): void;
    r(a: Rectangle): void;
    q(a: Rectangle): void;
    aj(): void;
    m(): boolean;
    readonly index: number;
    ad(): void;
    ab(): void;
    x(): void;
    av(a: Visibility): void;
    an(): void;
    w(a: AxisLabelSettings): void;
    private b;
    c(): AxisComponentsFromView;
    z(a: GeometryCollection): void;
    ay(): GeometryCollection;
    e(): PathRenderingInfo;
    a1(): GeometryCollection;
    az(): GeometryCollection;
    f(): PathRenderingInfo;
    a0(): GeometryCollection;
    g(): PathRenderingInfo;
    protected readonly d: AxisLabelPanelBase;
    at(a: Axis, b: Rect, c: Rect): void;
    y(): void;
    ap(a: number): void;
    au(a: List$1<any>, b: List$1<LabelPosition>): void;
    ao(a: number): void;
    v(): void;
    private h;
    o(a: number): string;
    n(dataItem_: any): any;
    protected k: RenderingContext;
    j: RenderingContext;
    af(a: RenderingContext, b: RenderingContext): void;
    private _isDirty;
    isDirty: boolean;
    protected ae(): void;
    undirty(a: boolean): void;
    private bb;
    protected al(a: boolean): void;
    postRender(): void;
    private a5;
    protected am(): void;
    ac(): void;
    aa(a: SeriesViewer): void;
    u(a: SeriesViewer): void;
    i(): FontInfo;
    l(): boolean;
    ak(): void;
    t(): void;
    aw(): void;
    s(a: AxisLabelSettings, b: string): void;
    preRender(): void;
    isValid(): boolean;
    a2(a: TextBlock): Point;
    a3(): Point;
    a6(): Rect;
    a4(a: TextBlock): Point;
    bd(a: TextBlock): Thickness;
    ah(): void;
}
/**
 * @hidden
 */
export declare class CategoryAxisBaseView extends AxisView {
    static $t: Type;
    protected be: CategoryAxisBase;
    constructor(a: CategoryAxisBase);
    o(a: number): string;
    bf(a: List$1<any>): number;
}
/**
 * @hidden
 */
export declare class HorizontalAxisLabelPanelBaseView extends AxisLabelPanelBaseView {
    static $t: Type;
    protected ax: HorizontalAxisLabelPanelBase;
    constructor(a: HorizontalAxisLabelPanelBase);
    az(): void;
    ay(): boolean;
    a0(a: List$1<Rect>): void;
}
/**
 * @hidden
 */
export declare class NumericAxisBaseView extends AxisView {
    static $t: Type;
    protected be: NumericAxisBase;
    constructor(a: NumericAxisBase);
    bf(): void;
    o(a: number): string;
}
/**
 * @hidden
 */
export declare class VerticalAxisLabelPanelView extends AxisLabelPanelBaseView {
    static $t: Type;
    protected ax: VerticalAxisLabelPanel;
    constructor(a: VerticalAxisLabelPanel);
    ay(): void;
    d(): FontInfo;
    protected aw(): Thickness;
    as(): Brush;
    az(a: List$1<Rect>, b: number): void;
}
/**
 * @hidden
 */
export declare class XamDataChartView extends SeriesViewerView {
    static $t: Type;
    constructor(a: XamDataChart);
    protected fd: XamDataChart;
    fh(a: any): void;
    protected dk(): void;
    dx(): void;
    fm: Brush;
    fi: Brush;
    fj: Brush;
    fl: Brush;
    fk: Brush;
    ff: number;
    fg: number;
    protected du(): void;
    fe: FontInfo;
}
/**
 * @hidden
 */
export declare class SeriesView extends Base implements ISchedulableRender, IProvidesViewport {
    static $t: Type;
    protected e: Series;
    p: boolean;
    constructor(a: Series);
    getDefaultTooltipTemplate(): string;
    am(): void;
    d: DataContext;
    ap(): void;
    getEffectiveViewport(): Rect;
    aw(): void;
    ag(): void;
    readonly t: DomRenderer;
    private _isDirty;
    isDirty: boolean;
    protected get_index(): number;
    readonly index: number;
    protected an(): void;
    undirty(a: boolean): void;
    private bt;
    ar(): void;
    private bk;
    bn(): Brush;
    s: number;
    private r;
    protected a1(a: boolean): void;
    private bo;
    protected ba(a: any, b: number, c: boolean): void;
    protected bd(a: any, b: number, c: boolean): void;
    protected x(a: number, b: boolean): any;
    protected y(a: number): any;
    protected z(a: number): any;
    protected bb(a: any, b: number): void;
    protected be(a: any, b: number): void;
    protected bc(a: any, b: number): void;
    protected bf(a: any, b: number): void;
    protected a7(a: boolean): void;
    protected a8(): void;
    protected a9(): void;
    private bj;
    protected bm(a: number): Brush;
    protected bl(): Brush;
    protected a3(a: RenderingContext, b: boolean): void;
    protected a2(a: RenderingContext, b: boolean): void;
    au(): void;
    aj(): void;
    ak(): void;
    private f;
    g(): SeriesComponentsFromView;
    a6(a: Canvas): void;
    q(): boolean;
    at(): void;
    as(): void;
    a4(): void;
    ae(): void;
    a5(): void;
    af(): void;
    c(a: any): DataContext;
    protected h: RenderingContext;
    protected i: RenderingContext;
    ao(a: RenderingContext, b: RenderingContext): void;
    private bp;
    br: Rect;
    bq: Rect;
    protected get_bs(): Rect;
    readonly bs: Rect;
    private j;
    n: boolean;
    ah(a: SeriesViewer): void;
    a: CanvasRenderScheduler;
    ad(a: SeriesViewer): void;
    postRender(): void;
    protected ax(): void;
    b(a: number): DataContext;
    az(a: RenderSurface): void;
    ai(a: any): void;
    bg(): void;
    aq(): void;
    av(): void;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    l(): boolean;
    protected o: boolean;
    bh(): void;
    a0(): void;
    protected ac(): void;
    al(): void;
    preRender(): void;
    isValid(): boolean;
    k: boolean;
    m: boolean;
    ay(a: RenderSurface): void;
    aa: string;
    bi(type_: StandardLegendItems): DataTemplate;
}
/**
 * @hidden
 */
export declare abstract class MarkerSeriesView extends SeriesView {
    static $t: Type;
    protected by: MarkerSeries;
    private b2;
    private b4;
    private b3;
    constructor(a: MarkerSeries);
    ap(): void;
    cd(): void;
    ck(a: boolean): void;
    protected b1: List$1<Marker>;
    bx(): Marker;
    abstract cc(a: (arg1: Marker) => void): void;
    cg(a: Marker): void;
    ci(a: Marker): void;
    ch(a: Marker): void;
    bz(): boolean;
    cb(): void;
    b5(): void;
    cm(a: Marker): Rect;
    b8(a: string): void;
    b9(): void;
    b6(): void;
    ca(): void;
    b7(): void;
    cj(): void;
    b0: boolean;
    protected be(a: any, b: number): void;
    private bu;
    protected bf(a: any, b: number): void;
    b(a: number): DataContext;
    private cl;
    protected a2(a: RenderingContext, b: boolean): void;
    ce(a: HashPool$2<any, Marker>): void;
    cf(a: Pool$1<Marker>): void;
    bv(a: Point): Marker;
    private bw;
}
/**
 * @hidden
 */
export declare class ChartAxisRangeChangedEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Axis, c: number, d: number, e: number, f: number);
    private _chart;
    chart: SeriesViewer;
    private _axis;
    axis: Axis;
    private _oldMinimumValue;
    oldMinimumValue: number;
    private _minimumValue;
    minimumValue: number;
    private _oldMaximumValue;
    oldMaximumValue: number;
    private _maximumValue;
    maximumValue: number;
}
